# REACT-BASIC-DESIGN

[![NPM version][npm-image]][npm-url]
[![Build][github-build]][github-build-url]
![npm-typescript]
[![License][github-license]][github-license-url]

UI components for faster and easier web development built with bootstrap for react.

## COMPATIBILITY VERSIONS

**react-basic-design** uses bootstrap components and you need to ensure
you are using the correct combination of versions.

| Basic Design Version | Bootstrap Version |
| -------------------- | :---------------: |
| 0.0.x                |        5.x        |
| 0.1.x                |        5.x        |

## INSTALL

Install via npm:

```
 > npm install  react-basic-design bootstrap react-bootstrap
```

## USAGE

```jsx
//import styles
import "bootstrap/scss/bootstrap.scss";
import "react-basic-design/dist/index.scss";

//import components
import * as bd from "react-basic-design";
```

## Demo

[https://mtalebian.github.io/react-basic-design-demo](https://mtalebian.github.io/react-basic-design-demo)

<!-- ## COMPONENTS

Inputs:

-   [Button](https://codesandbox.io/s/button-hbdvgl)
-   [Button Group](https://codesandbox.io/s/button-group-6oce5r)
-   [Checkbox](https://codesandbox.io/s/checkbox-ydkqst)
-   [Radio button](https://codesandbox.io/s/radio-button-0pd1vo)
-   [Switch](https://codesandbox.io/s/switch-hjfvk7)
-   [Text Field](https://codesandbox.io/s/text-field-4mn19t)

Data Display:

-   [Avatar](https://codesandbox.io/s/avatar-yh1rx5)
-   [Badge](https://codesandbox.io/s/badge-98qplt)
-   [List](https://codesandbox.io/s/list-q1rqgr)
-   [Table](https://codesandbox.io/s/table-4tz50l)

Surfaces:

-   [Accardion](https://codesandbox.io/s/accardion-e2dvq3)
-   [AppBar](https://codesandbox.io/s/appbar-gt1ogl)
-   [Card](https://codesandbox.io/s/card-jf51y6)
-   [Paper](https://codesandbox.io/s/paper-7en0u3)
-   [Panel](https://codesandbox.io/s/panel-h8zzbe)

Navigation:

-   [Tabs](https://codesandbox.io/s/tabs-ms16rj)

Layout:

-   [Form Row](https://codesandbox.io/s/form-row-ig3oub)
-   [Form](https://codesandbox.io/s/form-58971d)
-   [Flex](https://codesandbox.io/s/flex-7l9s0q)

Utils:

-   [msgbox](https://codesandbox.io/s/msgbox-fj6igi)
-   [Colors](https://codesandbox.io/s/colors-so7end)
-   [New CSS](https://codesandbox.io/s/new-css-j3f2dn) -->

## EXAMPLES

-   [Sample Login Form](https://codesandbox.io/s/basic-design-login-form-x7lk2)
-   [Sample Registeration Form](https://codesandbox.io/s/basic-design-registration-form-vdn59)
-   [Sample Feedback Form](https://codesandbox.io/s/basic-design-feedback-form-3hb1p)

[npm-image]: https://img.shields.io/npm/v/react-basic-design
[npm-url]: https://www.npmjs.com/package/react-basic-design
[github-build]: https://github.com/mtalebian/react-basic-design/actions/workflows/publish.yml/badge.svg
[github-build-url]: https://github.com/mtalebian/react-basic-design/actions/workflows/publish.yml
[npm-typescript]: https://img.shields.io/npm/types/react-basic-design
[github-license]: https://img.shields.io/github/license/mtalebian/react-basic-design
[github-license-url]: https://github.com/mtalebian/react-basic-design/blob/master/LICENSE
