import React from "react";
interface CardProps {
    className?: string;
    header?: string;
    footer?: string;
    shadow?: number;
    outline?: boolean;
    [x: string]: any;
}
/**
 * **Cards** contain content and actions about a single subject
 *
 * They should be easy to scan for relevant and actionable information.
 * Elements, like text and images, should be placed on them in a way that clearly indicates hierarchy.
 */
export declare const Card: ({ className, header, footer, shadow, outline, ...props }: CardProps) => React.JSX.Element;
export {};
