import * as React from 'react';
import React__default, { useRef, useEffect, useCallback, useState } from 'react';
import { Dropdown, Collapse, FormControl, Modal, Nav } from 'react-bootstrap';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
}

function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var classnames = {exports: {}};

/*!
	Copyright (c) 2018 Jed Watson.
	Licensed under the MIT License (MIT), see
	http://jedwatson.github.io/classnames
*/

(function (module) {
	/* global define */

	(function () {

		var hasOwn = {}.hasOwnProperty;

		function classNames() {
			var classes = [];

			for (var i = 0; i < arguments.length; i++) {
				var arg = arguments[i];
				if (!arg) continue;

				var argType = typeof arg;

				if (argType === 'string' || argType === 'number') {
					classes.push(arg);
				} else if (Array.isArray(arg)) {
					if (arg.length) {
						var inner = classNames.apply(null, arg);
						if (inner) {
							classes.push(inner);
						}
					}
				} else if (argType === 'object') {
					if (arg.toString !== Object.prototype.toString && !arg.toString.toString().includes('[native code]')) {
						classes.push(arg.toString());
						continue;
					}

					for (var key in arg) {
						if (hasOwn.call(arg, key) && arg[key]) {
							classes.push(key);
						}
					}
				}
			}

			return classes.join(' ');
		}

		if (module.exports) {
			classNames.default = classNames;
			module.exports = classNames;
		} else {
			window.classNames = classNames;
		}
	}()); 
} (classnames));

var classnamesExports = classnames.exports;
var classNames = /*@__PURE__*/getDefaultExportFromCjs(classnamesExports);

var AppBar = function (_a) {
    var _b = _a.className, className = _b === void 0 ? null : _b, _c = _a.shadow, shadow = _c === void 0 ? 4 : _c, _d = _a.position, position = _d === void 0 ? null : _d, _e = _a.color, color = _e === void 0 ? null : _e, _f = _a.prominent, prominent = _f === void 0 ? false : _f, _g = _a.prominentSize, prominentSize = _g === void 0 ? null : _g, _h = _a.children, children = _h === void 0 ? null : _h, props = __rest(_a, ["className", "shadow", "position", "color", "prominent", "prominentSize", "children"]);
    if (!color)
        color = "primary";
    if (shadow === undefined || shadow === null)
        shadow = 4;
    var cnShadow = shadow > 0 && shadow <= 24 ? "shadow-".concat(shadow) : "";
    var cn = classNames("appbar", className, cnShadow, {
        "appbar-fixed": position === "fixed",
        "appbar-fixed appbar-bottom": position === "bottom",
        "appbar-absolute": position === "absolute",
        "appbar-sticky": position === "sticky",
        "appbar-inherit": color === "inherit",
        "appbar-primary": color === "primary",
        "appbar-secondary": color === "secondary",
        "appbar-shell": color === "shell",
        "appbar-default": color !== "inherit" && color !== "primary" && color !== "secondary",
        "appbar-prominent-sm": prominent && prominentSize === "sm",
        "appbar-prominent": prominent,
        "appbar-prominent-lg": prominent && prominentSize === "lg",
    });
    return (React__default.createElement("header", __assign({ className: cn }, props), children));
};

var Avatar = function (_a) {
    var _b = _a.src, src = _b === void 0 ? null : _b, _c = _a.content, content = _c === void 0 ? null : _c, _d = _a.size, size = _d === void 0 ? null : _d, _e = _a.className, className = _e === void 0 ? null : _e, _f = _a.rounded, rounded = _f === void 0 ? false : _f, _g = _a.square, square = _g === void 0 ? false : _g, _h = _a.children, children = _h === void 0 ? null : _h, props = __rest(_a, ["src", "content", "size", "className", "rounded", "square", "children"]);
    var cn = classNames("avatar", className, {
        "avatar-rounded": rounded,
        "avatar-square": square,
        "avatar-sm": size === "sm",
        "avatar-lg": size === "lg",
    });
    return (React__default.createElement("div", __assign({ className: cn }, props),
        !!src && React__default.createElement("img", { src: src, alt: "avatar" }),
        content,
        children));
};

var AvatarGroup = function (_a) {
    _a.className; var _c = _a.children, children = _c === void 0 ? null : _c, props = __rest(_a, ["className", "children"]);
    return (React__default.createElement("div", __assign({ className: "avatar-group" }, props), children));
};

var Badge = function (_a) {
    var value = _a.value, max = _a.max, showzero = _a.showzero, dot = _a.dot, overlapCircle = _a.overlapCircle, anim = _a.anim, className = _a.className, color = _a.color, position = _a.position, children = _a.children, props = __rest(_a, ["value", "max", "showzero", "dot", "overlapCircle", "anim", "className", "color", "position", "children"]);
    if (!position)
        position = "top-end";
    //if (!color) color = "primary";
    var cnBadge = classNames("badge", className, "badge-" + position, {
        "bg-primary": color === "primary",
        "bg-secondary": color === "secondary",
        "bg-danger": color === "danger",
        "text-primary": dot && color === "primary",
        "text-secondary": dot && color === "secondary",
        "text-danger": dot && color === "danger",
        "d-none": !value && !showzero && !dot,
        "badge-dot": !!dot,
        "badge-overlap-circle": overlapCircle,
        "badge-anim": !!anim,
    });
    var args = !dot || !color || !color.startsWith("#") ? {} : { color: color };
    var content = value > max ? "+" + max : value;
    if (!children) {
        return React__default.createElement("span", { className: cnBadge }, content);
    }
    else {
        return (React__default.createElement("span", __assign({ className: "badge-root" }, props),
            children,
            React__default.createElement("span", __assign({ className: cnBadge }, args), !dot && content)));
    }
};

function SvgClose(props) {
    return (React.createElement("svg", __assign({ xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", viewBox: "0 0 24 24" }, props),
        React.createElement("path", { d: "M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41z" })));
}

var Chip = function (_a) {
    //if (!color) color = "primary";
    var icon = _a.icon, label = _a.label, outline = _a.outline, className = _a.className, size = _a.size, deleteColor = _a.deleteColor, deleteIcon = _a.deleteIcon, onClick = _a.onClick, onDelete = _a.onDelete, props = __rest(_a, ["icon", "label", "outline", "className", "size", "deleteColor", "deleteIcon", "onClick", "onDelete"]);
    return (React__default.createElement("div", __assign({ className: classNames(className, "bd-chip-root", {
            "bd-chip-filled": !outline,
            "bd-chip-outlined": outline,
            "bd-chip-sm": size === "sm",
            "bd-chip-md": size === "md",
            "cur-pointer": onClick,
            "cur-default": !onClick,
        }) }, props, { onClick: onClick }),
        icon && React__default.createElement("span", { className: classNames("bd-chip-icon", { "m-s-1": size !== "md" && size !== "sm" }) }, icon),
        React__default.createElement("span", { className: "bd-chip" }, label),
        onDelete && (React__default.createElement(Button, { type: "button", variant: "icon", color: deleteColor, size: "sm", className: classNames("bd-chip-delete m-s-n2", { "m-e-1": size !== "md" && size !== "sm" }), onClick: function (ev) {
                if (onDelete)
                    onDelete();
                ev.stopPropagation();
            } }, deleteIcon !== null && deleteIcon !== void 0 ? deleteIcon : React__default.createElement(SvgClose, null)))));
};

var elem = null;
var base = null;
var childElement = null;
var destroy = function () {
    if (!elem)
        return;
    removeFocus(elem);
    //base.remove();
    base = null;
    elem = null;
    childElement = null;
};
var init = function (newElem) {
    if (newElem === elem)
        return true;
    destroy();
    if (!newElem || newElem.classList.contains("disabled") || newElem.classList.contains("no-ripple"))
        return false;
    elem = newElem;
    base = elem.getElementsByClassName("ripple-base")[0];
    if (base) {
        childElement = base.getElementsByTagName("span")[0];
    }
    else {
        base = document.createElement("span");
        base.classList.add("ripple-base");
        elem.appendChild(base);
        childElement = document.createElement("span");
        childElement.className = "";
        base.appendChild(childElement);
    }
    return true;
};
var pulse = function (element, clientX, clientY) {
    if (!init(element))
        return;
    var container = base;
    var pulseElem = document.createElement("span");
    container.appendChild(pulseElem);
    removeFocus(element);
    var w = container.clientWidth;
    var h = container.clientHeight;
    var radius = Math.max(w, h) / 2;
    var x = clientX ? clientX : 0;
    var y = clientY ? clientY : 0;
    if (x > 0 || y > 0) {
        var rect = element.getBoundingClientRect();
        x -= rect.left;
        y -= rect.top;
        w = Math.max(x, element.clientWidth - x);
        h = Math.max(y, element.clientHeight - y);
        radius = Math.max(w, h);
        x -= radius;
        y -= radius;
    }
    else {
        radius = Math.sqrt(w * w + h * h);
        x = w / 2 - radius;
        y = h / 2 - radius;
    }
    pulseElem.style.width = "".concat(radius * 2, "px");
    pulseElem.style.height = "".concat(radius * 2, "px");
    pulseElem.style.left = "".concat(x, "px");
    pulseElem.style.top = "".concat(y, "px");
    pulseElem.className = "ripple-pulse";
    setTimeout(function () { return pulseElem.remove(); }, 600);
};
var focus = function (element) {
    if (!init(element))
        return;
    var container = base;
    if (elem.getElementsByClassName("ripple-pulse")[0])
        return;
    if (childElement.className === "ripple-focus")
        return;
    var w = container.clientWidth;
    var h = container.clientHeight;
    if (w < 10 || h < 10)
        return;
    var sizePercent = Math.max(0.85, w < h ? w / h : h / w);
    var rippleSize = (Math.max(w, h) / 2) * sizePercent;
    if (w / 2 - rippleSize > 10)
        rippleSize = w / 2 - 5;
    else if (h / 2 - rippleSize > 10)
        rippleSize = h / 2 - 5;
    var x = w / 2;
    var y = h / 2;
    setChildElement("ripple-focus", x, y, rippleSize);
};
function setChildElement(className, x, y, radius) {
    childElement.style.width = "".concat(radius * 2, "px");
    childElement.style.height = "".concat(radius * 2, "px");
    childElement.style.left = "".concat(x - radius, "px");
    childElement.style.top = "".concat(y - radius, "px");
    childElement.style.animation = "";
    childElement.className = className;
}
var blur = function (element) {
    removeFocus(element);
    if (!element || element !== elem)
        return;
    //destroy();
};
var removeFocus = function (element) {
    if (!element)
        return;
    var focus = element.getElementsByClassName("ripple-focus")[0];
    if (focus) {
        focus.style.animation = "none";
        setTimeout(function () {
            focus.className = "";
        });
    }
};
var ripple = { init: init, pulse: pulse, focus: focus, blur: blur, removeFocus: removeFocus };

var FPS = 60;
// Sine
var easeInSine = function (x) { return 1 - Math.cos((x * Math.PI) / 2); };
var easeOutSine = function (x) { return Math.sin((x * Math.PI) / 2); };
var easeInOutSine = function (x) { return -(Math.cos(Math.PI * x) - 1) / 2; };
// Cubic
var easeInQuad = function (x) { return x * x; };
var easeOutQuad = function (x) { return 1 - (1 - x) * (1 - x); };
var easeInOutQuad = function (x) { return (x < 0.5 ? 2 * x * x : 1 - Math.pow(-2 * x + 2, 2) / 2); };
// Cubic
var easeInCubic = function (x) { return x * x * x; };
var easeOutCubic = function (x) { return 1 - Math.pow(1 - x, 3); };
var easeInOutCubic = function (x) { return (x < 0.5 ? 4 * x * x * x : 1 - Math.pow(-2 * x + 2, 3) / 2); };
// Quart
var easeInQuart = function (x) { return x * x * x * x; };
var easeOutQuart = function (x) { return 1 - Math.pow(1 - x, 4); };
var easeInOutQuart = function (x) { return (x < 0.5 ? 8 * x * x * x * x : 1 - Math.pow(-2 * x + 2, 4) / 2); };
// Quint
var easeInQuint = function (x) { return x * x * x * x * x; };
var easeOutQuint = function (x) { return 1 - Math.pow(1 - x, 5); };
var easeInOutQuint = function (x) { return (x < 0.5 ? 16 * x * x * x * x * x : 1 - Math.pow(-2 * x + 2, 5) / 2); };
// Expo
var easeInExpo = function (x) { return (x === 0 ? 0 : Math.pow(2, 10 * x - 10)); };
var easeOutExpo = function (x) { return (x === 1 ? 1 : 1 - Math.pow(2, -10 * x)); };
var easeInOutExpo = function (x) { return (x === 0 ? 0 : x === 1 ? 1 : x < 0.5 ? Math.pow(2, 20 * x - 10) / 2 : (2 - Math.pow(2, -20 * x + 10)) / 2); };
// Circ
var easeInCirc = function (x) { return 1 - Math.sqrt(1 - Math.pow(x, 2)); };
var easeOutCirc = function (x) { return Math.sqrt(1 - Math.pow(x - 1, 2)); };
var easeInOutCirc = function (x) { return (x < 0.5 ? (1 - Math.sqrt(1 - Math.pow(2 * x, 2))) / 2 : (Math.sqrt(1 - Math.pow(-2 * x + 2, 2)) + 1) / 2); };
// Back
var easeInBack = function (x) {
    var c1 = 1.70158;
    var c3 = c1 + 1;
    return c3 * x * x * x - c1 * x * x;
};
var easeOutBack = function (x) {
    var c1 = 1.70158;
    var c3 = c1 + 1;
    return 1 + c3 * Math.pow(x - 1, 3) + c1 * Math.pow(x - 1, 2);
};
var easeInOutBack = function (x) {
    var c1 = 1.70158;
    var c2 = c1 * 1.525;
    return x < 0.5 ? (Math.pow(2 * x, 2) * ((c2 + 1) * 2 * x - c2)) / 2 : (Math.pow(2 * x - 2, 2) * ((c2 + 1) * (x * 2 - 2) + c2) + 2) / 2;
};
// Elastic
var easeInElasticfunction = function (x) {
    var c4 = (2 * Math.PI) / 3;
    return x === 0 ? 0 : x === 1 ? 1 : -Math.pow(2, 10 * x - 10) * Math.sin((x * 10 - 10.75) * c4);
};
var easeOutElastic = function (x) {
    var c4 = (2 * Math.PI) / 3;
    return x === 0 ? 0 : x === 1 ? 1 : Math.pow(2, -10 * x) * Math.sin((x * 10 - 0.75) * c4) + 1;
};
var easeInOutElastic = function (x) {
    var c5 = (2 * Math.PI) / 4.5;
    return x === 0
        ? 0
        : x === 1
            ? 1
            : x < 0.5
                ? -(Math.pow(2, 20 * x - 10) * Math.sin((20 * x - 11.125) * c5)) / 2
                : (Math.pow(2, -20 * x + 10) * Math.sin((20 * x - 11.125) * c5)) / 2 + 1;
};
// Bounce
var easeInBounce = function (x) { return 1 - easeOutBounce(1 - x); };
var easeOutBounce = function (x) {
    var n1 = 7.5625;
    var d1 = 2.75;
    if (x < 1 / d1)
        return n1 * x * x;
    else if (x < 2 / d1)
        return n1 * (x -= 1.5 / d1) * x + 0.75;
    else if (x < 2.5 / d1)
        return n1 * (x -= 2.25 / d1) * x + 0.9375;
    else
        return n1 * (x -= 2.625 / d1) * x + 0.984375;
};
var easeInOutBounce = function (x) { return (x < 0.5 ? (1 - easeOutBounce(1 - 2 * x)) / 2 : (1 + easeOutBounce(2 * x - 1)) / 2); };
//
//
//
//
//
var easings = {
    // Sine
    easeInSine: easeInSine,
    easeOutSine: easeOutSine,
    easeInOutSine: easeInOutSine,
    // Quad
    easeInQuad: easeInQuad,
    easeOutQuad: easeOutQuad,
    easeInOutQuad: easeInOutQuad,
    // Cubic
    easeInCubic: easeInCubic,
    easeOutCubic: easeOutCubic,
    easeInOutCubic: easeInOutCubic,
    // Quart
    easeInQuart: easeInQuart,
    easeOutQuart: easeOutQuart,
    easeInOutQuart: easeInOutQuart,
    // Quint
    easeInQuint: easeInQuint,
    easeOutQuint: easeOutQuint,
    easeInOutQuint: easeInOutQuint,
    // Expo
    easeInExpo: easeInExpo,
    easeOutExpo: easeOutExpo,
    easeInOutExpo: easeInOutExpo,
    // Circ
    easeInCirc: easeInCirc,
    easeOutCirc: easeOutCirc,
    easeInOutCirc: easeInOutCirc,
    // Back
    easeInBack: easeInBack,
    easeOutBack: easeOutBack,
    easeInOutBack: easeInOutBack,
    // Elastic
    easeInElasticfunction: easeInElasticfunction,
    easeOutElastic: easeOutElastic,
    easeInOutElastic: easeInOutElastic,
    // Bounce
    easeInBounce: easeInBounce,
    easeOutBounce: easeOutBounce,
    easeInOutBounce: easeInOutBounce,
    //
    createBezierEasing: function (p1, p2) { return function (t) {
        var c = 3 * p1, b = 3 * (p2 - p1) - c, a = 1 - c - b, t2 = t * t;
        return a * t2 * t + b * t2 + c * t;
    }; },
};
//-----------
var Transition = function (easing, duration) {
    var self = this;
    var startTime = 0;
    var on_change = null;
    self.startPos = 0;
    self.endPos = 0;
    self.busy = false;
    if (typeof easing === "string")
        easing = easings[easing];
    if (!easing)
        easing = easings.createBezierEasing(0, 1);
    self.start = function (start, end, onChange) {
        startTime = Date.now();
        self.startPos = start;
        self.endPos = end;
        on_change = onChange;
        if (!self.busy)
            tick();
    };
    var tick = function () {
        if (!on_change)
            return;
        var t = (Date.now() - startTime) / duration;
        self.busy = true;
        //---
        var v = t >= 1 ? self.endPos : self.startPos + (self.endPos - self.startPos) * easing(t);
        on_change(v);
        self.busy = t < 1;
        if (self.busy)
            requestFrame(tick);
    };
};
var requestFrame = (function () {
    return (window.requestAnimationFrame ||
        window["webkitRequestAnimationFrame"] ||
        window["mozRequestAnimationFrame"] ||
        window["oRequestAnimationFrame"] ||
        window["msRequestAnimationFrame"] ||
        function (func) {
            window.setTimeout(func, 1000 / FPS);
        });
})();

var addClassNamesToBody = function (elem, list) {
    if (typeof list === "string")
        list = list.split(" ");
    for (var i = 0; i < list.length; i++) {
        elem.classList.add(list[i]);
    }
};
var removeClassNamesFromBody = function (elem, list) {
    if (typeof list === "string")
        list = list.split(" ");
    for (var i = 0; i < list.length; i++) {
        elem.classList.remove(list[i]);
    }
};
var classNameExistsInBody = function (className) { return document.body.classList.contains(className); };
var getCssList = function (value) {
    var list = [];
    if (!value)
        return list;
    list.push("theme-" + value);
    if (value.startsWith("bs-"))
        list.push("theme-bs");
    if (value.startsWith("bd-"))
        list.push("theme-bd");
    if (value.endsWith("-default"))
        list.push("theme-light");
    if (value.endsWith("-light"))
        list.push("theme-light");
    if (value.endsWith("-dark"))
        list.push("theme-dark");
    return list;
};
/***********************/
var helper = {
    getTheme: function () { return localStorage.getItem("bd-theme"); },
    setTheme: function (value) {
        if (!value)
            value = "bd-quartz-light";
        localStorage.setItem("bd-theme", value);
        //
        var lst = [];
        var cl = document.body.classList;
        for (var i = 0; i < cl.length; i++) {
            if (cl[i].startsWith("theme-"))
                lst.push(cl[i]);
        }
        removeClassNamesFromBody(document.body, lst);
        var css_list = getCssList(value);
        addClassNamesToBody(document.body, css_list);
    },
    isDarkMode: function () {
        var t = helper.getTheme();
        return !!t && t.indexOf("dark") >= 0;
    },
    isRTL: function () { return classNameExistsInBody("rtl"); },
    getRTL: function () { return localStorage.getItem("bd-dir") == "rtl"; },
    setRTL: function (value) {
        var css = value ? "rtl" : "ltr";
        localStorage.setItem("bd-dir", css);
        removeClassNamesFromBody(document.body, value ? "ltr" : "rtl");
        addClassNamesToBody(document.body, css);
    },
};
/***********************/
var t = helper.getTheme();
helper.setTheme(!t ? "bd-quartz-light" : t);
helper.setRTL(helper.getRTL());

var Flex = function (_a) {
    var _b;
    var inline = _a.inline, reverse = _a.reverse, vertical = _a.vertical, content = _a.content, align = _a.align, wrap = _a.wrap, grow = _a.grow, gap = _a.gap, className = _a.className, children = _a.children, props = __rest(_a, ["inline", "reverse", "vertical", "content", "align", "wrap", "grow", "gap", "className", "children"]);
    var dir = reverse ? (vertical ? "flex-column-reverse" : "flex-row-reverse") : vertical ? "flex-column" : null;
    var cn = classNames(className, dir, (_b = {
            "d-flex": !inline,
            "d-inline-flex": inline,
            "flex-grow-1": grow,
            "flex-wrap": wrap === true,
            "flex-nowrap": wrap === "no",
            "flex-wrap-reverse": wrap === "reverse",
            "justify-content-start": content === "start",
            "justify-content-end": content === "end",
            "justify-content-center": content === "center",
            "justify-content-between": content === "between",
            "justify-content-around": content === "around",
            "align-items-start": align === "start",
            "align-items-end": align === "end",
            "align-items-center": align === "center",
            "align-items-baseline": align === "baseline",
            "align-items-stretch": align === "stretch"
        },
        _b["gap-" + gap] = !!gap,
        _b));
    return (React__default.createElement("div", __assign({ className: cn }, props), children));
};

var collectionUtils = {exports: {}};

var utils$3 = collectionUtils.exports = {};

/**
 * Loops through the collection and calls the callback for each element. if the callback returns truthy, the loop is broken and returns the same value.
 * @public
 * @param {*} collection The collection to loop through. Needs to have a length property set and have indices set from 0 to length - 1.
 * @param {function} callback The callback to be called for each element. The element will be given as a parameter to the callback. If this callback returns truthy, the loop is broken and the same value is returned.
 * @returns {*} The value that a callback has returned (if truthy). Otherwise nothing.
 */
utils$3.forEach = function(collection, callback) {
    for(var i = 0; i < collection.length; i++) {
        var result = callback(collection[i]);
        if(result) {
            return result;
        }
    }
};

var collectionUtilsExports = collectionUtils.exports;

var elementUtils = function(options) {
    var getState = options.stateHandler.getState;

    /**
     * Tells if the element has been made detectable and ready to be listened for resize events.
     * @public
     * @param {element} The element to check.
     * @returns {boolean} True or false depending on if the element is detectable or not.
     */
    function isDetectable(element) {
        var state = getState(element);
        return state && !!state.isDetectable;
    }

    /**
     * Marks the element that it has been made detectable and ready to be listened for resize events.
     * @public
     * @param {element} The element to mark.
     */
    function markAsDetectable(element) {
        getState(element).isDetectable = true;
    }

    /**
     * Tells if the element is busy or not.
     * @public
     * @param {element} The element to check.
     * @returns {boolean} True or false depending on if the element is busy or not.
     */
    function isBusy(element) {
        return !!getState(element).busy;
    }

    /**
     * Marks the object is busy and should not be made detectable.
     * @public
     * @param {element} element The element to mark.
     * @param {boolean} busy If the element is busy or not.
     */
    function markBusy(element, busy) {
        getState(element).busy = !!busy;
    }

    return {
        isDetectable: isDetectable,
        markAsDetectable: markAsDetectable,
        isBusy: isBusy,
        markBusy: markBusy
    };
};

var listenerHandler = function(idHandler) {
    var eventListeners = {};

    /**
     * Gets all listeners for the given element.
     * @public
     * @param {element} element The element to get all listeners for.
     * @returns All listeners for the given element.
     */
    function getListeners(element) {
        var id = idHandler.get(element);

        if (id === undefined) {
            return [];
        }

        return eventListeners[id] || [];
    }

    /**
     * Stores the given listener for the given element. Will not actually add the listener to the element.
     * @public
     * @param {element} element The element that should have the listener added.
     * @param {function} listener The callback that the element has added.
     */
    function addListener(element, listener) {
        var id = idHandler.get(element);

        if(!eventListeners[id]) {
            eventListeners[id] = [];
        }

        eventListeners[id].push(listener);
    }

    function removeListener(element, listener) {
        var listeners = getListeners(element);
        for (var i = 0, len = listeners.length; i < len; ++i) {
            if (listeners[i] === listener) {
              listeners.splice(i, 1);
              break;
            }
        }
    }

    function removeAllListeners(element) {
      var listeners = getListeners(element);
      if (!listeners) { return; }
      listeners.length = 0;
    }

    return {
        get: getListeners,
        add: addListener,
        removeListener: removeListener,
        removeAllListeners: removeAllListeners
    };
};

var idGenerator = function() {
    var idCount = 1;

    /**
     * Generates a new unique id in the context.
     * @public
     * @returns {number} A unique id in the context.
     */
    function generate() {
        return idCount++;
    }

    return {
        generate: generate
    };
};

var idHandler = function(options) {
    var idGenerator     = options.idGenerator;
    var getState        = options.stateHandler.getState;

    /**
     * Gets the resize detector id of the element.
     * @public
     * @param {element} element The target element to get the id of.
     * @returns {string|number|null} The id of the element. Null if it has no id.
     */
    function getId(element) {
        var state = getState(element);

        if (state && state.id !== undefined) {
            return state.id;
        }

        return null;
    }

    /**
     * Sets the resize detector id of the element. Requires the element to have a resize detector state initialized.
     * @public
     * @param {element} element The target element to set the id of.
     * @returns {string|number|null} The id of the element.
     */
    function setId(element) {
        var state = getState(element);

        if (!state) {
            throw new Error("setId required the element to have a resize detection state.");
        }

        var id = idGenerator.generate();

        state.id = id;

        return id;
    }

    return {
        get: getId,
        set: setId
    };
};

/* global console: false */

/**
 * Reporter that handles the reporting of logs, warnings and errors.
 * @public
 * @param {boolean} quiet Tells if the reporter should be quiet or not.
 */
var reporter = function(quiet) {
    function noop() {
        //Does nothing.
    }

    var reporter = {
        log: noop,
        warn: noop,
        error: noop
    };

    if(!quiet && window.console) {
        var attachFunction = function(reporter, name) {
            //The proxy is needed to be able to call the method with the console context,
            //since we cannot use bind.
            reporter[name] = function reporterProxy() {
                var f = console[name];
                if (f.apply) { //IE9 does not support console.log.apply :)
                    f.apply(console, arguments);
                } else {
                    for (var i = 0; i < arguments.length; i++) {
                        f(arguments[i]);
                    }
                }
            };
        };

        attachFunction(reporter, "log");
        attachFunction(reporter, "warn");
        attachFunction(reporter, "error");
    }

    return reporter;
};

var browserDetector$2 = {exports: {}};

var detector = browserDetector$2.exports = {};

detector.isIE = function(version) {
    function isAnyIeVersion() {
        var agent = navigator.userAgent.toLowerCase();
        return agent.indexOf("msie") !== -1 || agent.indexOf("trident") !== -1 || agent.indexOf(" edge/") !== -1;
    }

    if(!isAnyIeVersion()) {
        return false;
    }

    if(!version) {
        return true;
    }

    //Shamelessly stolen from https://gist.github.com/padolsey/527683
    var ieVersion = (function(){
        var undef,
            v = 3,
            div = document.createElement("div"),
            all = div.getElementsByTagName("i");

        do {
            div.innerHTML = "<!--[if gt IE " + (++v) + "]><i></i><![endif]-->";
        }
        while (all[0]);

        return v > 4 ? v : undef;
    }());

    return version === ieVersion;
};

detector.isLegacyOpera = function() {
    return !!window.opera;
};

var browserDetectorExports = browserDetector$2.exports;

var utils$2 = {exports: {}};

var utils$1 = utils$2.exports = {};

utils$1.getOption = getOption$1;

function getOption$1(options, name, defaultValue) {
    var value = options[name];

    if((value === undefined || value === null) && defaultValue !== undefined) {
        return defaultValue;
    }

    return value;
}

var utilsExports = utils$2.exports;

var utils = utilsExports;

var batchProcessor = function batchProcessorMaker(options) {
    options             = options || {};
    var reporter        = options.reporter;
    var asyncProcess    = utils.getOption(options, "async", true);
    var autoProcess     = utils.getOption(options, "auto", true);

    if(autoProcess && !asyncProcess) {
        reporter && reporter.warn("Invalid options combination. auto=true and async=false is invalid. Setting async=true.");
        asyncProcess = true;
    }

    var batch = Batch();
    var asyncFrameHandler;
    var isProcessing = false;

    function addFunction(level, fn) {
        if(!isProcessing && autoProcess && asyncProcess && batch.size() === 0) {
            // Since this is async, it is guaranteed to be executed after that the fn is added to the batch.
            // This needs to be done before, since we're checking the size of the batch to be 0.
            processBatchAsync();
        }

        batch.add(level, fn);
    }

    function processBatch() {
        // Save the current batch, and create a new batch so that incoming functions are not added into the currently processing batch.
        // Continue processing until the top-level batch is empty (functions may be added to the new batch while processing, and so on).
        isProcessing = true;
        while (batch.size()) {
            var processingBatch = batch;
            batch = Batch();
            processingBatch.process();
        }
        isProcessing = false;
    }

    function forceProcessBatch(localAsyncProcess) {
        if (isProcessing) {
            return;
        }

        if(localAsyncProcess === undefined) {
            localAsyncProcess = asyncProcess;
        }

        if(asyncFrameHandler) {
            cancelFrame(asyncFrameHandler);
            asyncFrameHandler = null;
        }

        if(localAsyncProcess) {
            processBatchAsync();
        } else {
            processBatch();
        }
    }

    function processBatchAsync() {
        asyncFrameHandler = requestFrame(processBatch);
    }

    function cancelFrame(listener) {
        // var cancel = window.cancelAnimationFrame || window.mozCancelAnimationFrame || window.webkitCancelAnimationFrame || window.clearTimeout;
        var cancel = clearTimeout;
        return cancel(listener);
    }

    function requestFrame(callback) {
        // var raf = window.requestAnimationFrame || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame || function(fn) { return window.setTimeout(fn, 20); };
        var raf = function(fn) { return setTimeout(fn, 0); };
        return raf(callback);
    }

    return {
        add: addFunction,
        force: forceProcessBatch
    };
};

function Batch() {
    var batch       = {};
    var size        = 0;
    var topLevel    = 0;
    var bottomLevel = 0;

    function add(level, fn) {
        if(!fn) {
            fn = level;
            level = 0;
        }

        if(level > topLevel) {
            topLevel = level;
        } else if(level < bottomLevel) {
            bottomLevel = level;
        }

        if(!batch[level]) {
            batch[level] = [];
        }

        batch[level].push(fn);
        size++;
    }

    function process() {
        for(var level = bottomLevel; level <= topLevel; level++) {
            var fns = batch[level];

            for(var i = 0; i < fns.length; i++) {
                var fn = fns[i];
                fn();
            }
        }
    }

    function getSize() {
        return size;
    }

    return {
        add: add,
        process: process,
        size: getSize
    };
}

var prop = "_erd";

function initState(element) {
    element[prop] = {};
    return getState(element);
}

function getState(element) {
    return element[prop];
}

function cleanState(element) {
    delete element[prop];
}

var stateHandler$1 = {
    initState: initState,
    getState: getState,
    cleanState: cleanState
};

/**
 * Resize detection strategy that injects objects to elements in order to detect resize events.
 * Heavily inspired by: http://www.backalleycoder.com/2013/03/18/cross-browser-event-based-element-resize-detection/
 */

var browserDetector$1 = browserDetectorExports;

var object = function(options) {
    options             = options || {};
    var reporter        = options.reporter;
    var batchProcessor  = options.batchProcessor;
    var getState        = options.stateHandler.getState;

    if(!reporter) {
        throw new Error("Missing required dependency: reporter.");
    }

    /**
     * Adds a resize event listener to the element.
     * @public
     * @param {element} element The element that should have the listener added.
     * @param {function} listener The listener callback to be called for each resize event of the element. The element will be given as a parameter to the listener callback.
     */
    function addListener(element, listener) {
        function listenerProxy() {
            listener(element);
        }

        if(browserDetector$1.isIE(8)) {
            //IE 8 does not support object, but supports the resize event directly on elements.
            getState(element).object = {
                proxy: listenerProxy
            };
            element.attachEvent("onresize", listenerProxy);
        } else {
            var object = getObject(element);

            if(!object) {
                throw new Error("Element is not detectable by this strategy.");
            }

            object.contentDocument.defaultView.addEventListener("resize", listenerProxy);
        }
    }

    function buildCssTextString(rules) {
        var seperator = options.important ? " !important; " : "; ";

        return (rules.join(seperator) + seperator).trim();
    }

    /**
     * Makes an element detectable and ready to be listened for resize events. Will call the callback when the element is ready to be listened for resize changes.
     * @private
     * @param {object} options Optional options object.
     * @param {element} element The element to make detectable
     * @param {function} callback The callback to be called when the element is ready to be listened for resize changes. Will be called with the element as first parameter.
     */
    function makeDetectable(options, element, callback) {
        if (!callback) {
            callback = element;
            element = options;
            options = null;
        }

        options = options || {};
        options.debug;

        function injectObject(element, callback) {
            var OBJECT_STYLE = buildCssTextString(["display: block", "position: absolute", "top: 0", "left: 0", "width: 100%", "height: 100%", "border: none", "padding: 0", "margin: 0", "opacity: 0", "z-index: -1000", "pointer-events: none"]);

            //The target element needs to be positioned (everything except static) so the absolute positioned object will be positioned relative to the target element.

            // Position altering may be performed directly or on object load, depending on if style resolution is possible directly or not.
            var positionCheckPerformed = false;

            // The element may not yet be attached to the DOM, and therefore the style object may be empty in some browsers.
            // Since the style object is a reference, it will be updated as soon as the element is attached to the DOM.
            var style = window.getComputedStyle(element);
            var width = element.offsetWidth;
            var height = element.offsetHeight;

            getState(element).startSize = {
                width: width,
                height: height
            };

            function mutateDom() {
                function alterPositionStyles() {
                    if(style.position === "static") {
                        element.style.setProperty("position", "relative", options.important ? "important" : "");

                        var removeRelativeStyles = function(reporter, element, style, property) {
                            function getNumericalValue(value) {
                                return value.replace(/[^-\d\.]/g, "");
                            }

                            var value = style[property];

                            if(value !== "auto" && getNumericalValue(value) !== "0") {
                                reporter.warn("An element that is positioned static has style." + property + "=" + value + " which is ignored due to the static positioning. The element will need to be positioned relative, so the style." + property + " will be set to 0. Element: ", element);
                                element.style.setProperty(property, "0", options.important ? "important" : "");
                            }
                        };

                        //Check so that there are no accidental styles that will make the element styled differently now that is is relative.
                        //If there are any, set them to 0 (this should be okay with the user since the style properties did nothing before [since the element was positioned static] anyway).
                        removeRelativeStyles(reporter, element, style, "top");
                        removeRelativeStyles(reporter, element, style, "right");
                        removeRelativeStyles(reporter, element, style, "bottom");
                        removeRelativeStyles(reporter, element, style, "left");
                    }
                }

                function onObjectLoad() {
                    // The object has been loaded, which means that the element now is guaranteed to be attached to the DOM.
                    if (!positionCheckPerformed) {
                        alterPositionStyles();
                    }

                    /*jshint validthis: true */

                    function getDocument(element, callback) {
                        //Opera 12 seem to call the object.onload before the actual document has been created.
                        //So if it is not present, poll it with an timeout until it is present.
                        //TODO: Could maybe be handled better with object.onreadystatechange or similar.
                        if(!element.contentDocument) {
                            var state = getState(element);
                            if (state.checkForObjectDocumentTimeoutId) {
                                window.clearTimeout(state.checkForObjectDocumentTimeoutId);
                            }
                            state.checkForObjectDocumentTimeoutId = setTimeout(function checkForObjectDocument() {
                                state.checkForObjectDocumentTimeoutId = 0;
                                getDocument(element, callback);
                            }, 100);

                            return;
                        }

                        callback(element.contentDocument);
                    }

                    //Mutating the object element here seems to fire another load event.
                    //Mutating the inner document of the object element is fine though.
                    var objectElement = this;

                    //Create the style element to be added to the object.
                    getDocument(objectElement, function onObjectDocumentReady(objectDocument) {
                        //Notify that the element is ready to be listened to.
                        callback(element);
                    });
                }

                // The element may be detached from the DOM, and some browsers does not support style resolving of detached elements.
                // The alterPositionStyles needs to be delayed until we know the element has been attached to the DOM (which we are sure of when the onObjectLoad has been fired), if style resolution is not possible.
                if (style.position !== "") {
                    alterPositionStyles();
                    positionCheckPerformed = true;
                }

                //Add an object element as a child to the target element that will be listened to for resize events.
                var object = document.createElement("object");
                object.style.cssText = OBJECT_STYLE;
                object.tabIndex = -1;
                object.type = "text/html";
                object.setAttribute("aria-hidden", "true");
                object.onload = onObjectLoad;

                //Safari: This must occur before adding the object to the DOM.
                //IE: Does not like that this happens before, even if it is also added after.
                if(!browserDetector$1.isIE()) {
                    object.data = "about:blank";
                }

                if (!getState(element)) {
                    // The element has been uninstalled before the actual loading happened.
                    return;
                }

                element.appendChild(object);
                getState(element).object = object;

                //IE: This must occur after adding the object to the DOM.
                if(browserDetector$1.isIE()) {
                    object.data = "about:blank";
                }
            }

            if(batchProcessor) {
                batchProcessor.add(mutateDom);
            } else {
                mutateDom();
            }
        }

        if(browserDetector$1.isIE(8)) {
            //IE 8 does not support objects properly. Luckily they do support the resize event.
            //So do not inject the object and notify that the element is already ready to be listened to.
            //The event handler for the resize event is attached in the utils.addListener instead.
            callback(element);
        } else {
            injectObject(element, callback);
        }
    }

    /**
     * Returns the child object of the target element.
     * @private
     * @param {element} element The target element.
     * @returns The object element of the target.
     */
    function getObject(element) {
        return getState(element).object;
    }

    function uninstall(element) {
        if (!getState(element)) {
            return;
        }

        var object = getObject(element);

        if (!object) {
            return;
        }

        if (browserDetector$1.isIE(8)) {
            element.detachEvent("onresize", object.proxy);
        } else {
            element.removeChild(object);
        }

        if (getState(element).checkForObjectDocumentTimeoutId) {
            window.clearTimeout(getState(element).checkForObjectDocumentTimeoutId);
        }

        delete getState(element).object;
    }

    return {
        makeDetectable: makeDetectable,
        addListener: addListener,
        uninstall: uninstall
    };
};

/**
 * Resize detection strategy that injects divs to elements in order to detect resize events on scroll events.
 * Heavily inspired by: https://github.com/marcj/css-element-queries/blob/master/src/ResizeSensor.js
 */

var forEach$1 = collectionUtilsExports.forEach;

var scroll = function(options) {
    options             = options || {};
    var reporter        = options.reporter;
    var batchProcessor  = options.batchProcessor;
    var getState        = options.stateHandler.getState;
    options.stateHandler.hasState;
    var idHandler       = options.idHandler;

    if (!batchProcessor) {
        throw new Error("Missing required dependency: batchProcessor");
    }

    if (!reporter) {
        throw new Error("Missing required dependency: reporter.");
    }

    //TODO: Could this perhaps be done at installation time?
    var scrollbarSizes = getScrollbarSizes();

    var styleId = "erd_scroll_detection_scrollbar_style";
    var detectionContainerClass = "erd_scroll_detection_container";

    function initDocument(targetDocument) {
        // Inject the scrollbar styling that prevents them from appearing sometimes in Chrome.
        // The injected container needs to have a class, so that it may be styled with CSS (pseudo elements).
        injectScrollStyle(targetDocument, styleId, detectionContainerClass);
    }

    initDocument(window.document);

    function buildCssTextString(rules) {
        var seperator = options.important ? " !important; " : "; ";

        return (rules.join(seperator) + seperator).trim();
    }

    function getScrollbarSizes() {
        var width = 500;
        var height = 500;

        var child = document.createElement("div");
        child.style.cssText = buildCssTextString(["position: absolute", "width: " + width*2 + "px", "height: " + height*2 + "px", "visibility: hidden", "margin: 0", "padding: 0"]);

        var container = document.createElement("div");
        container.style.cssText = buildCssTextString(["position: absolute", "width: " + width + "px", "height: " + height + "px", "overflow: scroll", "visibility: none", "top: " + -width*3 + "px", "left: " + -height*3 + "px", "visibility: hidden", "margin: 0", "padding: 0"]);

        container.appendChild(child);

        document.body.insertBefore(container, document.body.firstChild);

        var widthSize = width - container.clientWidth;
        var heightSize = height - container.clientHeight;

        document.body.removeChild(container);

        return {
            width: widthSize,
            height: heightSize
        };
    }

    function injectScrollStyle(targetDocument, styleId, containerClass) {
        function injectStyle(style, method) {
            method = method || function (element) {
                targetDocument.head.appendChild(element);
            };

            var styleElement = targetDocument.createElement("style");
            styleElement.innerHTML = style;
            styleElement.id = styleId;
            method(styleElement);
            return styleElement;
        }

        if (!targetDocument.getElementById(styleId)) {
            var containerAnimationClass = containerClass + "_animation";
            var containerAnimationActiveClass = containerClass + "_animation_active";
            var style = "/* Created by the element-resize-detector library. */\n";
            style += "." + containerClass + " > div::-webkit-scrollbar { " + buildCssTextString(["display: none"]) + " }\n\n";
            style += "." + containerAnimationActiveClass + " { " + buildCssTextString(["-webkit-animation-duration: 0.1s", "animation-duration: 0.1s", "-webkit-animation-name: " + containerAnimationClass, "animation-name: " + containerAnimationClass]) + " }\n";
            style += "@-webkit-keyframes " + containerAnimationClass +  " { 0% { opacity: 1; } 50% { opacity: 0; } 100% { opacity: 1; } }\n";
            style += "@keyframes " + containerAnimationClass +          " { 0% { opacity: 1; } 50% { opacity: 0; } 100% { opacity: 1; } }";
            injectStyle(style);
        }
    }

    function addAnimationClass(element) {
        element.className += " " + detectionContainerClass + "_animation_active";
    }

    function addEvent(el, name, cb) {
        if (el.addEventListener) {
            el.addEventListener(name, cb);
        } else if(el.attachEvent) {
            el.attachEvent("on" + name, cb);
        } else {
            return reporter.error("[scroll] Don't know how to add event listeners.");
        }
    }

    function removeEvent(el, name, cb) {
        if (el.removeEventListener) {
            el.removeEventListener(name, cb);
        } else if(el.detachEvent) {
            el.detachEvent("on" + name, cb);
        } else {
            return reporter.error("[scroll] Don't know how to remove event listeners.");
        }
    }

    function getExpandElement(element) {
        return getState(element).container.childNodes[0].childNodes[0].childNodes[0];
    }

    function getShrinkElement(element) {
        return getState(element).container.childNodes[0].childNodes[0].childNodes[1];
    }

    /**
     * Adds a resize event listener to the element.
     * @public
     * @param {element} element The element that should have the listener added.
     * @param {function} listener The listener callback to be called for each resize event of the element. The element will be given as a parameter to the listener callback.
     */
    function addListener(element, listener) {
        var listeners = getState(element).listeners;

        if (!listeners.push) {
            throw new Error("Cannot add listener to an element that is not detectable.");
        }

        getState(element).listeners.push(listener);
    }

    /**
     * Makes an element detectable and ready to be listened for resize events. Will call the callback when the element is ready to be listened for resize changes.
     * @private
     * @param {object} options Optional options object.
     * @param {element} element The element to make detectable
     * @param {function} callback The callback to be called when the element is ready to be listened for resize changes. Will be called with the element as first parameter.
     */
    function makeDetectable(options, element, callback) {
        if (!callback) {
            callback = element;
            element = options;
            options = null;
        }

        options = options || {};

        function debug() {
            if (options.debug) {
                var args = Array.prototype.slice.call(arguments);
                args.unshift(idHandler.get(element), "Scroll: ");
                if (reporter.log.apply) {
                    reporter.log.apply(null, args);
                } else {
                    for (var i = 0; i < args.length; i++) {
                        reporter.log(args[i]);
                    }
                }
            }
        }

        function isDetached(element) {
            function isInDocument(element) {
                var isInShadowRoot = element.getRootNode && element.getRootNode().contains(element);
                return element === element.ownerDocument.body || element.ownerDocument.body.contains(element) || isInShadowRoot;
            }

            if (!isInDocument(element)) {
                return true;
            }

            // FireFox returns null style in hidden iframes. See https://github.com/wnr/element-resize-detector/issues/68 and https://bugzilla.mozilla.org/show_bug.cgi?id=795520
            if (window.getComputedStyle(element) === null) {
                return true;
            }

            return false;
        }

        function isUnrendered(element) {
            // Check the absolute positioned container since the top level container is display: inline.
            var container = getState(element).container.childNodes[0];
            var style = window.getComputedStyle(container);
            return !style.width || style.width.indexOf("px") === -1; //Can only compute pixel value when rendered.
        }

        function getStyle() {
            // Some browsers only force layouts when actually reading the style properties of the style object, so make sure that they are all read here,
            // so that the user of the function can be sure that it will perform the layout here, instead of later (important for batching).
            var elementStyle            = window.getComputedStyle(element);
            var style                   = {};
            style.position              = elementStyle.position;
            style.width                 = element.offsetWidth;
            style.height                = element.offsetHeight;
            style.top                   = elementStyle.top;
            style.right                 = elementStyle.right;
            style.bottom                = elementStyle.bottom;
            style.left                  = elementStyle.left;
            style.widthCSS              = elementStyle.width;
            style.heightCSS             = elementStyle.height;
            return style;
        }

        function storeStartSize() {
            var style = getStyle();
            getState(element).startSize = {
                width: style.width,
                height: style.height
            };
            debug("Element start size", getState(element).startSize);
        }

        function initListeners() {
            getState(element).listeners = [];
        }

        function storeStyle() {
            debug("storeStyle invoked.");
            if (!getState(element)) {
                debug("Aborting because element has been uninstalled");
                return;
            }

            var style = getStyle();
            getState(element).style = style;
        }

        function storeCurrentSize(element, width, height) {
            getState(element).lastWidth = width;
            getState(element).lastHeight  = height;
        }

        function getExpandChildElement(element) {
            return getExpandElement(element).childNodes[0];
        }

        function getWidthOffset() {
            return 2 * scrollbarSizes.width + 1;
        }

        function getHeightOffset() {
            return 2 * scrollbarSizes.height + 1;
        }

        function getExpandWidth(width) {
            return width + 10 + getWidthOffset();
        }

        function getExpandHeight(height) {
            return height + 10 + getHeightOffset();
        }

        function getShrinkWidth(width) {
            return width * 2 + getWidthOffset();
        }

        function getShrinkHeight(height) {
            return height * 2 + getHeightOffset();
        }

        function positionScrollbars(element, width, height) {
            var expand          = getExpandElement(element);
            var shrink          = getShrinkElement(element);
            var expandWidth     = getExpandWidth(width);
            var expandHeight    = getExpandHeight(height);
            var shrinkWidth     = getShrinkWidth(width);
            var shrinkHeight    = getShrinkHeight(height);
            expand.scrollLeft   = expandWidth;
            expand.scrollTop    = expandHeight;
            shrink.scrollLeft   = shrinkWidth;
            shrink.scrollTop    = shrinkHeight;
        }

        function injectContainerElement() {
            var container = getState(element).container;

            if (!container) {
                container                   = document.createElement("div");
                container.className         = detectionContainerClass;
                container.style.cssText     = buildCssTextString(["visibility: hidden", "display: inline", "width: 0px", "height: 0px", "z-index: -1", "overflow: hidden", "margin: 0", "padding: 0"]);
                getState(element).container = container;
                addAnimationClass(container);
                element.appendChild(container);

                var onAnimationStart = function () {
                    getState(element).onRendered && getState(element).onRendered();
                };

                addEvent(container, "animationstart", onAnimationStart);

                // Store the event handler here so that they may be removed when uninstall is called.
                // See uninstall function for an explanation why it is needed.
                getState(element).onAnimationStart = onAnimationStart;
            }

            return container;
        }

        function injectScrollElements() {
            function alterPositionStyles() {
                var style = getState(element).style;

                if(style.position === "static") {
                    element.style.setProperty("position", "relative",options.important ? "important" : "");

                    var removeRelativeStyles = function(reporter, element, style, property) {
                        function getNumericalValue(value) {
                            return value.replace(/[^-\d\.]/g, "");
                        }

                        var value = style[property];

                        if(value !== "auto" && getNumericalValue(value) !== "0") {
                            reporter.warn("An element that is positioned static has style." + property + "=" + value + " which is ignored due to the static positioning. The element will need to be positioned relative, so the style." + property + " will be set to 0. Element: ", element);
                            element.style[property] = 0;
                        }
                    };

                    //Check so that there are no accidental styles that will make the element styled differently now that is is relative.
                    //If there are any, set them to 0 (this should be okay with the user since the style properties did nothing before [since the element was positioned static] anyway).
                    removeRelativeStyles(reporter, element, style, "top");
                    removeRelativeStyles(reporter, element, style, "right");
                    removeRelativeStyles(reporter, element, style, "bottom");
                    removeRelativeStyles(reporter, element, style, "left");
                }
            }

            function getLeftTopBottomRightCssText(left, top, bottom, right) {
                left = (!left ? "0" : (left + "px"));
                top = (!top ? "0" : (top + "px"));
                bottom = (!bottom ? "0" : (bottom + "px"));
                right = (!right ? "0" : (right + "px"));

                return ["left: " + left, "top: " + top, "right: " + right, "bottom: " + bottom];
            }

            debug("Injecting elements");

            if (!getState(element)) {
                debug("Aborting because element has been uninstalled");
                return;
            }

            alterPositionStyles();

            var rootContainer = getState(element).container;

            if (!rootContainer) {
                rootContainer = injectContainerElement();
            }

            // Due to this WebKit bug https://bugs.webkit.org/show_bug.cgi?id=80808 (currently fixed in Blink, but still present in WebKit browsers such as Safari),
            // we need to inject two containers, one that is width/height 100% and another that is left/top -1px so that the final container always is 1x1 pixels bigger than
            // the targeted element.
            // When the bug is resolved, "containerContainer" may be removed.

            // The outer container can occasionally be less wide than the targeted when inside inline elements element in WebKit (see https://bugs.webkit.org/show_bug.cgi?id=152980).
            // This should be no problem since the inner container either way makes sure the injected scroll elements are at least 1x1 px.

            var scrollbarWidth          = scrollbarSizes.width;
            var scrollbarHeight         = scrollbarSizes.height;
            var containerContainerStyle = buildCssTextString(["position: absolute", "flex: none", "overflow: hidden", "z-index: -1", "visibility: hidden", "width: 100%", "height: 100%", "left: 0px", "top: 0px"]);
            var containerStyle          = buildCssTextString(["position: absolute", "flex: none", "overflow: hidden", "z-index: -1", "visibility: hidden"].concat(getLeftTopBottomRightCssText(-(1 + scrollbarWidth), -(1 + scrollbarHeight), -scrollbarHeight, -scrollbarWidth)));
            var expandStyle             = buildCssTextString(["position: absolute", "flex: none", "overflow: scroll", "z-index: -1", "visibility: hidden", "width: 100%", "height: 100%"]);
            var shrinkStyle             = buildCssTextString(["position: absolute", "flex: none", "overflow: scroll", "z-index: -1", "visibility: hidden", "width: 100%", "height: 100%"]);
            var expandChildStyle        = buildCssTextString(["position: absolute", "left: 0", "top: 0"]);
            var shrinkChildStyle        = buildCssTextString(["position: absolute", "width: 200%", "height: 200%"]);

            var containerContainer      = document.createElement("div");
            var container               = document.createElement("div");
            var expand                  = document.createElement("div");
            var expandChild             = document.createElement("div");
            var shrink                  = document.createElement("div");
            var shrinkChild             = document.createElement("div");

            // Some browsers choke on the resize system being rtl, so force it to ltr. https://github.com/wnr/element-resize-detector/issues/56
            // However, dir should not be set on the top level container as it alters the dimensions of the target element in some browsers.
            containerContainer.dir              = "ltr";

            containerContainer.style.cssText    = containerContainerStyle;
            containerContainer.className        = detectionContainerClass;
            container.className                 = detectionContainerClass;
            container.style.cssText             = containerStyle;
            expand.style.cssText                = expandStyle;
            expandChild.style.cssText           = expandChildStyle;
            shrink.style.cssText                = shrinkStyle;
            shrinkChild.style.cssText           = shrinkChildStyle;

            expand.appendChild(expandChild);
            shrink.appendChild(shrinkChild);
            container.appendChild(expand);
            container.appendChild(shrink);
            containerContainer.appendChild(container);
            rootContainer.appendChild(containerContainer);

            function onExpandScroll() {
                var state = getState(element);
                if (state && state.onExpand) {
                    state.onExpand();
                } else {
                    debug("Aborting expand scroll handler: element has been uninstalled");
                }
            }

            function onShrinkScroll() {
                var state = getState(element);
                if (state && state.onShrink) {
                    state.onShrink();
                } else {
                    debug("Aborting shrink scroll handler: element has been uninstalled");
                }
            }

            addEvent(expand, "scroll", onExpandScroll);
            addEvent(shrink, "scroll", onShrinkScroll);

            // Store the event handlers here so that they may be removed when uninstall is called.
            // See uninstall function for an explanation why it is needed.
            getState(element).onExpandScroll = onExpandScroll;
            getState(element).onShrinkScroll = onShrinkScroll;
        }

        function registerListenersAndPositionElements() {
            function updateChildSizes(element, width, height) {
                var expandChild             = getExpandChildElement(element);
                var expandWidth             = getExpandWidth(width);
                var expandHeight            = getExpandHeight(height);
                expandChild.style.setProperty("width", expandWidth + "px", options.important ? "important" : "");
                expandChild.style.setProperty("height", expandHeight + "px", options.important ? "important" : "");
            }

            function updateDetectorElements(done) {
                var width           = element.offsetWidth;
                var height          = element.offsetHeight;

                // Check whether the size has actually changed since last time the algorithm ran. If not, some steps may be skipped.
                var sizeChanged = width !== getState(element).lastWidth || height !== getState(element).lastHeight;

                debug("Storing current size", width, height);

                // Store the size of the element sync here, so that multiple scroll events may be ignored in the event listeners.
                // Otherwise the if-check in handleScroll is useless.
                storeCurrentSize(element, width, height);

                // Since we delay the processing of the batch, there is a risk that uninstall has been called before the batch gets to execute.
                // Since there is no way to cancel the fn executions, we need to add an uninstall guard to all fns of the batch.

                batchProcessor.add(0, function performUpdateChildSizes() {
                    if (!sizeChanged) {
                        return;
                    }

                    if (!getState(element)) {
                        debug("Aborting because element has been uninstalled");
                        return;
                    }

                    if (!areElementsInjected()) {
                        debug("Aborting because element container has not been initialized");
                        return;
                    }

                    if (options.debug) {
                        var w = element.offsetWidth;
                        var h = element.offsetHeight;

                        if (w !== width || h !== height) {
                            reporter.warn(idHandler.get(element), "Scroll: Size changed before updating detector elements.");
                        }
                    }

                    updateChildSizes(element, width, height);
                });

                batchProcessor.add(1, function updateScrollbars() {
                    // This function needs to be invoked event though the size is unchanged. The element could have been resized very quickly and then
                    // been restored to the original size, which will have changed the scrollbar positions.

                    if (!getState(element)) {
                        debug("Aborting because element has been uninstalled");
                        return;
                    }

                    if (!areElementsInjected()) {
                        debug("Aborting because element container has not been initialized");
                        return;
                    }

                    positionScrollbars(element, width, height);
                });

                if (sizeChanged && done) {
                    batchProcessor.add(2, function () {
                        if (!getState(element)) {
                            debug("Aborting because element has been uninstalled");
                            return;
                        }

                        if (!areElementsInjected()) {
                          debug("Aborting because element container has not been initialized");
                          return;
                        }

                        done();
                    });
                }
            }

            function areElementsInjected() {
                return !!getState(element).container;
            }

            function notifyListenersIfNeeded() {
                function isFirstNotify() {
                    return getState(element).lastNotifiedWidth === undefined;
                }

                debug("notifyListenersIfNeeded invoked");

                var state = getState(element);

                // Don't notify if the current size is the start size, and this is the first notification.
                if (isFirstNotify() && state.lastWidth === state.startSize.width && state.lastHeight === state.startSize.height) {
                    return debug("Not notifying: Size is the same as the start size, and there has been no notification yet.");
                }

                // Don't notify if the size already has been notified.
                if (state.lastWidth === state.lastNotifiedWidth && state.lastHeight === state.lastNotifiedHeight) {
                    return debug("Not notifying: Size already notified");
                }


                debug("Current size not notified, notifying...");
                state.lastNotifiedWidth = state.lastWidth;
                state.lastNotifiedHeight = state.lastHeight;
                forEach$1(getState(element).listeners, function (listener) {
                    listener(element);
                });
            }

            function handleRender() {
                debug("startanimation triggered.");

                if (isUnrendered(element)) {
                    debug("Ignoring since element is still unrendered...");
                    return;
                }

                debug("Element rendered.");
                var expand = getExpandElement(element);
                var shrink = getShrinkElement(element);
                if (expand.scrollLeft === 0 || expand.scrollTop === 0 || shrink.scrollLeft === 0 || shrink.scrollTop === 0) {
                    debug("Scrollbars out of sync. Updating detector elements...");
                    updateDetectorElements(notifyListenersIfNeeded);
                }
            }

            function handleScroll() {
                debug("Scroll detected.");

                if (isUnrendered(element)) {
                    // Element is still unrendered. Skip this scroll event.
                    debug("Scroll event fired while unrendered. Ignoring...");
                    return;
                }

                updateDetectorElements(notifyListenersIfNeeded);
            }

            debug("registerListenersAndPositionElements invoked.");

            if (!getState(element)) {
                debug("Aborting because element has been uninstalled");
                return;
            }

            getState(element).onRendered = handleRender;
            getState(element).onExpand = handleScroll;
            getState(element).onShrink = handleScroll;

            var style = getState(element).style;
            updateChildSizes(element, style.width, style.height);
        }

        function finalizeDomMutation() {
            debug("finalizeDomMutation invoked.");

            if (!getState(element)) {
                debug("Aborting because element has been uninstalled");
                return;
            }

            var style = getState(element).style;
            storeCurrentSize(element, style.width, style.height);
            positionScrollbars(element, style.width, style.height);
        }

        function ready() {
            callback(element);
        }

        function install() {
            debug("Installing...");
            initListeners();
            storeStartSize();

            batchProcessor.add(0, storeStyle);
            batchProcessor.add(1, injectScrollElements);
            batchProcessor.add(2, registerListenersAndPositionElements);
            batchProcessor.add(3, finalizeDomMutation);
            batchProcessor.add(4, ready);
        }

        debug("Making detectable...");

        if (isDetached(element)) {
            debug("Element is detached");

            injectContainerElement();

            debug("Waiting until element is attached...");

            getState(element).onRendered = function () {
                debug("Element is now attached");
                install();
            };
        } else {
            install();
        }
    }

    function uninstall(element) {
        var state = getState(element);

        if (!state) {
            // Uninstall has been called on a non-erd element.
            return;
        }

        // Uninstall may have been called in the following scenarios:
        // (1) Right between the sync code and async batch (here state.busy = true, but nothing have been registered or injected).
        // (2) In the ready callback of the last level of the batch by another element (here, state.busy = true, but all the stuff has been injected).
        // (3) After the installation process (here, state.busy = false and all the stuff has been injected).
        // So to be on the safe side, let's check for each thing before removing.

        // We need to remove the event listeners, because otherwise the event might fire on an uninstall element which results in an error when trying to get the state of the element.
        state.onExpandScroll && removeEvent(getExpandElement(element), "scroll", state.onExpandScroll);
        state.onShrinkScroll && removeEvent(getShrinkElement(element), "scroll", state.onShrinkScroll);
        state.onAnimationStart && removeEvent(state.container, "animationstart", state.onAnimationStart);

        state.container && element.removeChild(state.container);
    }

    return {
        makeDetectable: makeDetectable,
        addListener: addListener,
        uninstall: uninstall,
        initDocument: initDocument
    };
};

var forEach                 = collectionUtilsExports.forEach;
var elementUtilsMaker       = elementUtils;
var listenerHandlerMaker    = listenerHandler;
var idGeneratorMaker        = idGenerator;
var idHandlerMaker          = idHandler;
var reporterMaker           = reporter;
var browserDetector         = browserDetectorExports;
var batchProcessorMaker     = batchProcessor;
var stateHandler            = stateHandler$1;

//Detection strategies.
var objectStrategyMaker     = object;
var scrollStrategyMaker     = scroll;

function isCollection(obj) {
    return Array.isArray(obj) || obj.length !== undefined;
}

function toArray(collection) {
    if (!Array.isArray(collection)) {
        var array = [];
        forEach(collection, function (obj) {
            array.push(obj);
        });
        return array;
    } else {
        return collection;
    }
}

function isElement(obj) {
    return obj && obj.nodeType === 1;
}

/**
 * @typedef idHandler
 * @type {object}
 * @property {function} get Gets the resize detector id of the element.
 * @property {function} set Generate and sets the resize detector id of the element.
 */

/**
 * @typedef Options
 * @type {object}
 * @property {boolean} callOnAdd    Determines if listeners should be called when they are getting added.
                                    Default is true. If true, the listener is guaranteed to be called when it has been added.
                                    If false, the listener will not be guarenteed to be called when it has been added (does not prevent it from being called).
 * @property {idHandler} idHandler  A custom id handler that is responsible for generating, setting and retrieving id's for elements.
                                    If not provided, a default id handler will be used.
 * @property {reporter} reporter    A custom reporter that handles reporting logs, warnings and errors.
                                    If not provided, a default id handler will be used.
                                    If set to false, then nothing will be reported.
 * @property {boolean} debug        If set to true, the the system will report debug messages as default for the listenTo method.
 */

/**
 * Creates an element resize detector instance.
 * @public
 * @param {Options?} options Optional global options object that will decide how this instance will work.
 */
var elementResizeDetector = function(options) {
    options = options || {};

    //idHandler is currently not an option to the listenTo function, so it should not be added to globalOptions.
    var idHandler;

    if (options.idHandler) {
        // To maintain compatability with idHandler.get(element, readonly), make sure to wrap the given idHandler
        // so that readonly flag always is true when it's used here. This may be removed next major version bump.
        idHandler = {
            get: function (element) { return options.idHandler.get(element, true); },
            set: options.idHandler.set
        };
    } else {
        var idGenerator = idGeneratorMaker();
        var defaultIdHandler = idHandlerMaker({
            idGenerator: idGenerator,
            stateHandler: stateHandler
        });
        idHandler = defaultIdHandler;
    }

    //reporter is currently not an option to the listenTo function, so it should not be added to globalOptions.
    var reporter = options.reporter;

    if(!reporter) {
        //If options.reporter is false, then the reporter should be quiet.
        var quiet = reporter === false;
        reporter = reporterMaker(quiet);
    }

    //batchProcessor is currently not an option to the listenTo function, so it should not be added to globalOptions.
    var batchProcessor = getOption(options, "batchProcessor", batchProcessorMaker({ reporter: reporter }));

    //Options to be used as default for the listenTo function.
    var globalOptions = {};
    globalOptions.callOnAdd     = !!getOption(options, "callOnAdd", true);
    globalOptions.debug         = !!getOption(options, "debug", false);

    var eventListenerHandler    = listenerHandlerMaker(idHandler);
    var elementUtils            = elementUtilsMaker({
        stateHandler: stateHandler
    });

    //The detection strategy to be used.
    var detectionStrategy;
    var desiredStrategy = getOption(options, "strategy", "object");
    var importantCssRules = getOption(options, "important", false);
    var strategyOptions = {
        reporter: reporter,
        batchProcessor: batchProcessor,
        stateHandler: stateHandler,
        idHandler: idHandler,
        important: importantCssRules
    };

    if(desiredStrategy === "scroll") {
        if (browserDetector.isLegacyOpera()) {
            reporter.warn("Scroll strategy is not supported on legacy Opera. Changing to object strategy.");
            desiredStrategy = "object";
        } else if (browserDetector.isIE(9)) {
            reporter.warn("Scroll strategy is not supported on IE9. Changing to object strategy.");
            desiredStrategy = "object";
        }
    }

    if(desiredStrategy === "scroll") {
        detectionStrategy = scrollStrategyMaker(strategyOptions);
    } else if(desiredStrategy === "object") {
        detectionStrategy = objectStrategyMaker(strategyOptions);
    } else {
        throw new Error("Invalid strategy name: " + desiredStrategy);
    }

    //Calls can be made to listenTo with elements that are still being installed.
    //Also, same elements can occur in the elements list in the listenTo function.
    //With this map, the ready callbacks can be synchronized between the calls
    //so that the ready callback can always be called when an element is ready - even if
    //it wasn't installed from the function itself.
    var onReadyCallbacks = {};

    /**
     * Makes the given elements resize-detectable and starts listening to resize events on the elements. Calls the event callback for each event for each element.
     * @public
     * @param {Options?} options Optional options object. These options will override the global options. Some options may not be overriden, such as idHandler.
     * @param {element[]|element} elements The given array of elements to detect resize events of. Single element is also valid.
     * @param {function} listener The callback to be executed for each resize event for each element.
     */
    function listenTo(options, elements, listener) {
        function onResizeCallback(element) {
            var listeners = eventListenerHandler.get(element);
            forEach(listeners, function callListenerProxy(listener) {
                listener(element);
            });
        }

        function addListener(callOnAdd, element, listener) {
            eventListenerHandler.add(element, listener);

            if(callOnAdd) {
                listener(element);
            }
        }

        //Options object may be omitted.
        if(!listener) {
            listener = elements;
            elements = options;
            options = {};
        }

        if(!elements) {
            throw new Error("At least one element required.");
        }

        if(!listener) {
            throw new Error("Listener required.");
        }

        if (isElement(elements)) {
            // A single element has been passed in.
            elements = [elements];
        } else if (isCollection(elements)) {
            // Convert collection to array for plugins.
            // TODO: May want to check so that all the elements in the collection are valid elements.
            elements = toArray(elements);
        } else {
            return reporter.error("Invalid arguments. Must be a DOM element or a collection of DOM elements.");
        }

        var elementsReady = 0;

        var callOnAdd = getOption(options, "callOnAdd", globalOptions.callOnAdd);
        var onReadyCallback = getOption(options, "onReady", function noop() {});
        var debug = getOption(options, "debug", globalOptions.debug);

        forEach(elements, function attachListenerToElement(element) {
            if (!stateHandler.getState(element)) {
                stateHandler.initState(element);
                idHandler.set(element);
            }

            var id = idHandler.get(element);

            debug && reporter.log("Attaching listener to element", id, element);

            if(!elementUtils.isDetectable(element)) {
                debug && reporter.log(id, "Not detectable.");
                if(elementUtils.isBusy(element)) {
                    debug && reporter.log(id, "System busy making it detectable");

                    //The element is being prepared to be detectable. Do not make it detectable.
                    //Just add the listener, because the element will soon be detectable.
                    addListener(callOnAdd, element, listener);
                    onReadyCallbacks[id] = onReadyCallbacks[id] || [];
                    onReadyCallbacks[id].push(function onReady() {
                        elementsReady++;

                        if(elementsReady === elements.length) {
                            onReadyCallback();
                        }
                    });
                    return;
                }

                debug && reporter.log(id, "Making detectable...");
                //The element is not prepared to be detectable, so do prepare it and add a listener to it.
                elementUtils.markBusy(element, true);
                return detectionStrategy.makeDetectable({ debug: debug, important: importantCssRules }, element, function onElementDetectable(element) {
                    debug && reporter.log(id, "onElementDetectable");

                    if (stateHandler.getState(element)) {
                        elementUtils.markAsDetectable(element);
                        elementUtils.markBusy(element, false);
                        detectionStrategy.addListener(element, onResizeCallback);
                        addListener(callOnAdd, element, listener);

                        // Since the element size might have changed since the call to "listenTo", we need to check for this change,
                        // so that a resize event may be emitted.
                        // Having the startSize object is optional (since it does not make sense in some cases such as unrendered elements), so check for its existance before.
                        // Also, check the state existance before since the element may have been uninstalled in the installation process.
                        var state = stateHandler.getState(element);
                        if (state && state.startSize) {
                            var width = element.offsetWidth;
                            var height = element.offsetHeight;
                            if (state.startSize.width !== width || state.startSize.height !== height) {
                                onResizeCallback(element);
                            }
                        }

                        if(onReadyCallbacks[id]) {
                            forEach(onReadyCallbacks[id], function(callback) {
                                callback();
                            });
                        }
                    } else {
                        // The element has been unisntalled before being detectable.
                        debug && reporter.log(id, "Element uninstalled before being detectable.");
                    }

                    delete onReadyCallbacks[id];

                    elementsReady++;
                    if(elementsReady === elements.length) {
                        onReadyCallback();
                    }
                });
            }

            debug && reporter.log(id, "Already detecable, adding listener.");

            //The element has been prepared to be detectable and is ready to be listened to.
            addListener(callOnAdd, element, listener);
            elementsReady++;
        });

        if(elementsReady === elements.length) {
            onReadyCallback();
        }
    }

    function uninstall(elements) {
        if(!elements) {
            return reporter.error("At least one element is required.");
        }

        if (isElement(elements)) {
            // A single element has been passed in.
            elements = [elements];
        } else if (isCollection(elements)) {
            // Convert collection to array for plugins.
            // TODO: May want to check so that all the elements in the collection are valid elements.
            elements = toArray(elements);
        } else {
            return reporter.error("Invalid arguments. Must be a DOM element or a collection of DOM elements.");
        }

        forEach(elements, function (element) {
            eventListenerHandler.removeAllListeners(element);
            detectionStrategy.uninstall(element);
            stateHandler.cleanState(element);
        });
    }

    function initDocument(targetDocument) {
        detectionStrategy.initDocument && detectionStrategy.initDocument(targetDocument);
    }

    return {
        listenTo: listenTo,
        removeListener: eventListenerHandler.removeListener,
        removeAllListeners: eventListenerHandler.removeAllListeners,
        uninstall: uninstall,
        initDocument: initDocument
    };
};

function getOption(options, name, defaultValue) {
    var value = options[name];

    if((value === undefined || value === null) && defaultValue !== undefined) {
        return defaultValue;
    }

    return value;
}

var createResizeDetector = /*@__PURE__*/getDefaultExportFromCjs(elementResizeDetector);

var erd = createResizeDetector({ strategy: "scroll" });
var watchers = [];
function getWatcher(elem) {
    for (var i = 0; i < watchers.length; ++i) {
        if (watchers[i].elem == elem)
            return watchers[i];
    }
    var v = { elem: elem, width: 0, height: 0 };
    watchers.push(v);
    return v;
}
var ResizeWatch = React__default.forwardRef(function (_a, ref) {
    var as = _a.as, dimension = _a.dimension, onResize = _a.onResize, children = _a.children, props = __rest(_a, ["as", "dimension", "onResize", "children"]);
    var lastSize = useRef({ w: 0, h: 0 });
    var debouncedOnResize = onResize;
    if (!ref)
        ref = useRef(null);
    var sizeWatcher = function (element) {
        var w = element.offsetWidth;
        var h = element.offsetHeight;
        var z = getWatcher(element);
        var w_changed = w !== z.width;
        var h_changed = h !== z.height;
        var changed = dimension === "width" ? w_changed : dimension === "height" ? h_changed : w_changed || h_changed;
        z.width = w;
        z.height = h;
        if (changed)
            debouncedOnResize(w, h);
    };
    useEffect(function () {
        //return () => debouncedOnResize.cancel();
    }, []);
    useEffect(function () {
        var element = ref.current;
        if (!onResize || !element)
            return;
        var w = element.offsetWidth;
        var h = element.offsetHeight;
        var z = lastSize.current;
        var w_changed = w !== z.width;
        var h_changed = h !== z.height;
        var changed = dimension === "width" ? w_changed : dimension === "height" ? h_changed : w_changed || h_changed;
        lastSize.current = { w: w, h: h };
        if (changed)
            debouncedOnResize(w, h);
    });
    useEffect(function () {
        var instance = ref.current;
        if (!onResize || !instance)
            return;
        erd.listenTo(instance, sizeWatcher);
        return function () { return erd.uninstall(instance); };
    }, [ref, ref.current]);
    props = __assign(__assign({}, props), { ref: ref });
    if (!as)
        as = "div";
    return React__default.createElement(as, props, children);
});

var Phantom = function (_a) {
    var children = _a.children, props = __rest(_a, ["children"]);
    var MapChildren = function (children) {
        return React__default.Children.map(children, function (child) {
            if (!React__default.isValidElement(child))
                return child;
            var newProps = __assign(__assign({}, props), child.props);
            return React__default.cloneElement(child, newProps);
            /*
            return !child.props?.children
                ? child
                : React.cloneElement(child, { ...child.props, children: MapChildren(child.props.children) });
            */
        });
    };
    return !props ? children : MapChildren(children);
};

var useAutoFocus = function (delay, ref) {
    if (delay === void 0) { delay = 200; }
    return useCallback(function (elem) {
        if (elem) {
            if (ref)
                ref.current = elem;
            setTimeout(function () {
                elem.focus();
            }, delay);
        }
    }, []);
};

var Button = function (_a) {
    var active = _a.active, variant = _a.variant, className = _a.className, color = _a.color, size = _a.size, pill = _a.pill, edge = _a.edge, menu = _a.menu, drop = _a.drop, align = _a.align, position = _a.position, href = _a.href, disableRipple = _a.disableRipple, disabled = _a.disabled, onFocus = _a.onFocus, onBlur = _a.onBlur, onMouseLeave = _a.onMouseLeave, onMouseDown = _a.onMouseDown, onClick = _a.onClick, children = _a.children, props = __rest(_a, ["active", "variant", "className", "color", "size", "pill", "edge", "menu", "drop", "align", "position", "href", "disableRipple", "disabled", "onFocus", "onBlur", "onMouseLeave", "onMouseDown", "onClick", "children"]);
    var cn = "btn ";
    //------
    var is_rtl = helper.isRTL();
    if (is_rtl) {
        switch (drop) {
            case "start":
                drop = "end";
                break;
            case "end":
                drop = "start";
                break;
            default:
                if (!align || align === "start")
                    align = "end";
                else if (align === "end")
                    align = "start";
        }
    }
    //------
    if (color === "inherit")
        color = "";
    else if (!color)
        color = "primary";
    if (!variant)
        variant = "text";
    //------
    if (variant === "icon") {
        cn += " btn-icon";
        if (color)
            cn += " btn-text-".concat(color);
    }
    else if (variant === "text") {
        cn += " btn-text";
        if (color)
            cn += " btn-text-".concat(color);
    }
    else if (variant === "outline") {
        cn += " btn-outline";
        if (color)
            cn += " btn-outline-".concat(color);
    }
    else if (variant === "fab") {
        cn += " btn-fab";
        if (color)
            cn += " btn-".concat(color);
    }
    else if (variant === "contained" || variant === "flat") {
        if (!!color) {
            cn += " btn-contained btn-".concat(color);
        }
    }
    cn = classNames(className, cn, {
        "rounded-circle": variant === "fab" && !pill,
        "btn-active": active,
        "btn-flat": variant === "flat",
        "btn-sm": size === "sm",
        "btn-md": size === "md",
        "btn-lg": size === "lg",
        "rounded-pill": pill,
        "btn-disabled": !!disabled,
        "pe-none": !!disabled && !!href,
        "btn-edge-start": edge === "start",
        "btn-edge-end": edge === "end",
        "dropdown-no-caret": (variant === "icon" || variant === "fab") && menu,
        "fab-start": position === "bottom-start",
        "fab-center": position === "bottom-center",
        "fab-end": position === "bottom-end",
    });
    var newProps;
    newProps = {
        onFocus: function (e) {
            if (!disableRipple) {
                ripple.focus(e.currentTarget);
            }
            if (onFocus)
                onFocus(e);
        },
        onBlur: function (e) {
            if (!disableRipple) {
                ripple.blur(e.currentTarget);
            }
            if (onBlur)
                onBlur(e);
        },
        onMouseLeave: function (e) {
            if (!disableRipple) {
                ripple.removeFocus(e.currentTarget);
            }
            if (onMouseLeave)
                onMouseLeave(e);
        },
        onMouseDown: function (e) {
            if (!disableRipple) {
                ripple.pulse(e.currentTarget, e.clientX, e.clientY);
            }
            if (onMouseDown)
                onMouseDown(e);
        },
    };
    if (onClick)
        newProps = __assign(__assign({}, newProps), { onClick: onClick });
    if (disabled)
        newProps = __assign(__assign({}, newProps), { disabled: disabled });
    if (menu) {
        var dropdownProps = { drop: drop, align: align };
        return (React__default.createElement(Dropdown, __assign({}, dropdownProps),
            React__default.createElement(Dropdown.Toggle, __assign({ as: "button", className: cn }, newProps, props), children),
            menu));
    }
    else if (!!href)
        return (React__default.createElement("a", __assign({ className: cn, href: href }, newProps, props), children));
    return (React__default.createElement("button", __assign({ className: cn }, newProps, props), children));
};

var ButtonGroup = function (_a) {
    var variant = _a.variant, color = _a.color, size = _a.size, align = _a.align, vertical = _a.vertical, className = _a.className, children = _a.children, props = __rest(_a, ["variant", "color", "size", "align", "vertical", "className", "children"]);
    var cn = classNames(className, {
        "justify-content-start": align === "start",
        "justify-content-end": align === "end",
        "justify-content-center": align === "center",
        "flex-column": vertical,
        "shadow-2": variant == "contained",
        "btn-group": !vertical,
        "btn-group-vertical": vertical,
    });
    var MapChildren = function (children) {
        return React__default.Children.map(children, function (child) {
            var _a, _b;
            if (!React__default.isValidElement(child))
                return child;
            var x = child;
            if ((x === null || x === void 0 ? void 0 : x.type) === Button) {
                var newProps = __assign(__assign({ variant: variant, color: color, size: size }, child.props), { children: MapChildren((_a = child.props) === null || _a === void 0 ? void 0 : _a.children) });
                return React__default.cloneElement(child, newProps);
            }
            return !((_b = child.props) === null || _b === void 0 ? void 0 : _b.children)
                ? child
                : React__default.cloneElement(child, __assign(__assign({}, child.props), { children: MapChildren(child.props.children) }));
        });
    };
    return (React__default.createElement("div", __assign({ className: cn }, props), MapChildren(children)));
};

var CardFooter = function (_a) {
    var className = _a.className, muted = _a.muted, children = _a.children, props = __rest(_a, ["className", "muted", "children"]);
    return (React__default.createElement("div", __assign({ className: classNames("card-footer", className, {
            "text-muted": muted,
        }) }, props), children));
};

var CardHeader = function (_a) {
    var title = _a.title; _a.subtitle; _a.avatar; _a.actions; var className = _a.className, h4 = _a.h4, h5 = _a.h5, h6 = _a.h6, children = _a.children, props = __rest(_a, ["title", "subtitle", "avatar", "actions", "className", "h4", "h5", "h6", "children"]);
    if (h4)
        return (React__default.createElement("h4", __assign({ className: classNames("card-header", className) }, props), children));
    if (h5)
        return (React__default.createElement("h5", __assign({ className: classNames("card-header", className) }, props), children));
    if (h6)
        return (React__default.createElement("h6", __assign({ className: classNames("card-header", className) }, props), children));
    return (React__default.createElement("div", __assign({ className: classNames("card-header", className) }, props),
        title,
        children));
};

/**
 * **Cards** contain content and actions about a single subject
 *
 * They should be easy to scan for relevant and actionable information.
 * Elements, like text and images, should be placed on them in a way that clearly indicates hierarchy.
 */
var Card = function (_a) {
    var _b;
    var className = _a.className, header = _a.header, footer = _a.footer, shadow = _a.shadow, outline = _a.outline, props = __rest(_a, ["className", "header", "footer", "shadow", "outline"]);
    if (outline === true)
        shadow = 0;
    var cn = classNames("card", className, shadow, (_b = {},
        _b["shadow-" + shadow] = shadow >= 0 && shadow <= 24,
        _b["border-0"] = !outline,
        _b));
    return (React__default.createElement("div", __assign({ className: cn }, props),
        !!header && React__default.createElement(CardHeader, null, header),
        props.children,
        !!footer && React__default.createElement(CardFooter, null, footer)));
};

var CardTitle = function (_a) {
    var className = _a.className, props = __rest(_a, ["className"]);
    return (React__default.createElement("h5", __assign({ className: classNames("card-title", className) }, props), props.children));
};

var CardBody = function (_a) {
    var className = _a.className, title = _a.title, props = __rest(_a, ["className", "title"]);
    return (React__default.createElement("div", __assign({ className: classNames("card-body", className) }, props),
        !!title && React__default.createElement(CardTitle, null, title),
        props.children));
};

var CardMedia = function (_a) {
    var className = _a.className, image = _a.image, width = _a.width, height = _a.height, children = _a.children, props = __rest(_a, ["className", "image", "width", "height", "children"]);
    return (React__default.createElement("div", __assign({ className: classNames("card-media", className), style: { backgroundImage: "url(".concat(image, ")"), width: width, height: height } }, props), children));
};

var CardSubTitle = function (_a) {
    var className = _a.className, muted = _a.muted, props = __rest(_a, ["className", "muted"]);
    return (React__default.createElement("h6", __assign({ className: classNames("card-subtitle", className, {
            "text-muted": muted,
        }) }, props), props.children));
};

var CardText = function (_a) {
    var className = _a.className, justify = _a.justify, center = _a.center, muted = _a.muted, props = __rest(_a, ["className", "justify", "center", "muted"]);
    var cn = classNames("card-text", className, {
        "text-justify": justify,
        "text-center": center,
        "text-muted": muted,
    });
    return (React__default.createElement("p", __assign({ className: cn }, props), props.children));
};

var Form = function (_a) {
    var as = _a.as, action = _a.action, className = _a.className, labelWidth = _a.labelWidth, labelClassName = _a.labelClassName, controlClassName = _a.controlClassName, compact = _a.compact, inline = _a.inline, 
    //initialValues,
    //validationSchema,
    onSubmit = _a.onSubmit, 
    //innerRef,
    //validate,
    //enableReinitialize,
    //setFildValue,
    height = _a.height, width = _a.width, maxWidth = _a.maxWidth, maxHeight = _a.maxHeight, style = _a.style, children = _a.children, props = __rest(_a, ["as", "action", "className", "labelWidth", "labelClassName", "controlClassName", "compact", "inline", "onSubmit", "height", "width", "maxWidth", "maxHeight", "style", "children"]);
    var cn = classNames("bd-form", className, {
        "form-vertical": !inline || !labelWidth,
        "bd-form-inline": inline,
        "bd-form-compact": compact,
    });
    var MapChildren = function (children) {
        return React__default.Children.map(children, function (child) {
            var _a, _b;
            if (!React__default.isValidElement(child))
                return child;
            var x = child;
            if ((x === null || x === void 0 ? void 0 : x.type) === FormRow) {
                var newProps = __assign(__assign({ labelWidth: labelWidth, labelClassName: labelClassName, controlClassName: controlClassName }, child.props), { children: MapChildren((_a = child.props) === null || _a === void 0 ? void 0 : _a.children) });
                return React__default.cloneElement(child, newProps);
            }
            return !((_b = child.props) === null || _b === void 0 ? void 0 : _b.children)
                ? child
                : React__default.cloneElement(child, __assign(__assign({}, child.props), { children: MapChildren(child.props.children) }));
        });
    };
    if (action)
        props.action = action;
    if (cn)
        props.className = cn;
    if (onSubmit)
        props.onSubmit = onSubmit;
    if (style || height || width || maxWidth || maxHeight)
        props.style = __assign(__assign({}, style), { width: width, maxWidth: maxWidth, height: height, maxHeight: maxHeight });
    children = MapChildren(children);
    return as ? React__default.createElement(as, props, children) : React__default.createElement("form", __assign({}, props), children);
};

var FormRow = function (_a) {
    var _b;
    var small = _a.small, label = _a.label, labelWidth = _a.labelWidth, labelClassName = _a.labelClassName, labelStyle = _a.labelStyle, htmlFor = _a.htmlFor, className = _a.className, controlClassName = _a.controlClassName, width = _a.width, height = _a.height, maxWidth = _a.maxWidth, maxLabelWidth = _a.maxLabelWidth, style = _a.style, children = _a.children, props = _a.props;
    var break_point = typeof labelWidth !== "string" ? "md" : labelWidth.startsWith("lg") ? "lg" : labelWidth.startsWith("xl") ? "xl" : "md";
    labelWidth = typeof labelWidth !== "string" || labelWidth.indexOf("-") === -1 ? labelWidth : labelWidth.split("-")[1];
    labelWidth = labelWidth * 1;
    var label_break_point = !labelWidth ? "" : "col-".concat(break_point, "-").concat(labelWidth);
    var control_break_point = !labelWidth ? "" : "col-".concat(break_point, "-").concat(12 - labelWidth);
    var cn = classNames("bd-form-row", className, { "row gx-3": labelWidth });
    var cnLabel = classNames(labelClassName, "form-label", (_b = {},
        _b["text-start text-".concat(break_point, "-end col-form-label col-12 ").concat(label_break_point)] = labelWidth,
        _b["d-none d-".concat(break_point, "-block")] = label == null && labelWidth,
        _b["d-none"] = label == null && !labelWidth,
        _b["text-muted small m-0"] = small,
        _b));
    var label_style = maxLabelWidth ? __assign(__assign({}, labelStyle), { maxWidth: maxLabelWidth }) : __assign({}, labelStyle);
    var field_comp = children;
    if (labelWidth > 0) {
        field_comp = (React__default.createElement("div", { className: classNames(controlClassName, "d-flex align-items-center col-12 ".concat(control_break_point)) }, field_comp));
    }
    else {
        field_comp = (React__default.createElement("div", { className: classNames(controlClassName, "d-flex align-items-center col-12 ".concat(control_break_point)) }, field_comp));
    }
    return (React__default.createElement(React__default.Fragment, null,
        React__default.createElement("div", __assign({ className: cn, style: __assign(__assign({}, style), { maxWidth: maxWidth, width: width, height: height }) }, props),
            React__default.createElement("label", { className: cnLabel, htmlFor: htmlFor, style: label_style }, label === "" || label === " " ? React__default.createElement(React__default.Fragment, null, "\u00A0") : label),
            field_comp)));
};

var TextField = function (_a) {
    var _b = _a.variant, variant = _b === void 0 ? "outline" : _b, id = _a.id, _c = _a.type, type = _c === void 0 ? "text" : _c, _d = _a.autoComplete, autoComplete = _d === void 0 ? "off" : _d, _e = _a.spellCheck, spellCheck = _e === void 0 ? false : _e, autoFocus = _a.autoFocus, readOnly = _a.readOnly, disabled = _a.disabled, inputClassName = _a.inputClassName, inputStyle = _a.inputStyle, inputRef = _a.inputRef, error = _a.error, showErrorLabel = _a.showErrorLabel, buttonIcon = _a.buttonIcon, buttonOnClick = _a.buttonOnClick, items = _a.items, className = _a.className, height = _a.height, width = _a.width, maxWidth = _a.maxWidth, style = _a.style, onChange = _a.onChange, children = _a.children, props = __rest(_a, ["variant", "id", "type", "autoComplete", "spellCheck", "autoFocus", "readOnly", "disabled", "inputClassName", "inputStyle", "inputRef", "error", "showErrorLabel", "buttonIcon", "buttonOnClick", "items", "className", "height", "width", "maxWidth", "style", "onChange", "children"]);
    if (autoFocus)
        inputRef = useAutoFocus(200, inputRef);
    if (!type)
        type = "text";
    if (children && (type === "select" || type === "textarea"))
        type = "text";
    var is_select = type === "select";
    var is_textarea = type === "textarea";
    var cnInput = classNames(inputClassName, {
        "form-control": !is_select,
        "form-select": is_select,
        "bd-input-fill": variant === "fill",
        "bd-input-standard": variant === "standard",
        "has-1-btn": buttonIcon,
        "bd-input-readonly": readOnly,
        "bd-input-disabled": disabled,
        "bd-border-error": error,
    });
    if (is_select) {
        if (readOnly)
            disabled = true;
        readOnly = undefined;
        type = undefined;
    }
    if (is_textarea) {
        type = undefined;
    }
    var newProps = __assign(__assign({ id: id, type: type, ref: inputRef, className: cnInput, autoComplete: autoComplete, spellCheck: spellCheck, readOnly: readOnly, disabled: disabled, style: __assign(__assign({}, inputStyle), { height: height }), onChange: onChange }, props), { title: error });
    var getValue = function (item) {
        return !item || typeof item !== "object" ? item : "id" in item ? item["id"] : "code" in item ? item["code"] : item;
    };
    var getText = function (item) { return (!item || typeof item !== "object" ? item : "title" in item ? item["title"] : item); };
    var inp = null;
    if (is_textarea)
        inp = React__default.createElement("textarea", __assign({}, newProps));
    else if (is_select)
        inp = (React__default.createElement("select", __assign({}, newProps), items.map(function (x) { return (React__default.createElement("option", { key: getValue(x), value: getValue(x) }, getText(x))); })));
    else
        inp = React__default.createElement("input", __assign({}, newProps));
    if (children) {
        return (React__default.createElement(Dropdown, null,
            React__default.createElement("div", { className: classNames("bd-input", className), style: __assign(__assign({}, style), { width: width, maxWidth: maxWidth }) },
                inp,
                React__default.createElement(Dropdown.Toggle, { className: "btn1 icon-btn btn btn-text bg-transparent text-primary", type: "button" }),
                showErrorLabel && error && React__default.createElement("div", { className: "bd-error" }, error)),
            React__default.createElement(Dropdown.Menu, { align: helper.isRTL() ? "start" : "end", className: "w-100 overflow-hidden" }, children)));
    }
    return (React__default.createElement("div", { className: classNames("bd-input", className), style: __assign(__assign({}, style), { width: width, maxWidth: maxWidth }) },
        inp,
        buttonIcon && (React__default.createElement(Button, { type: "button", className: "btn1 size-md icon-btn", onClick: buttonOnClick }, buttonIcon)),
        showErrorLabel && error && React__default.createElement("div", { className: "bd-error small" }, error)));
};

var ListDivider = function () { return null; };

function SvgChevronRight(props) {
    return (React.createElement("svg", __assign({ xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", viewBox: "0 0 24 24" }, props),
        React.createElement("path", { d: "M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6-6-6z" })));
}

function SvgCheckBox(props) {
    return (React.createElement("svg", __assign({ xmlns: "http://www.w3.org/2000/svg", height: "1em", viewBox: "0 0 24 24", width: "1em" }, props),
        React.createElement("path", { d: "M0 0h24v24H0z", fill: "none" }),
        React.createElement("path", { d: "M19 3H5a2 2 0 00-2 2v14a2 2 0 002 2h14a2 2 0 002-2V5a2 2 0 00-2-2zm-9 14l-5-5 1.41-1.41L10 14.17l7.59-7.59L19 8l-9 9z" })));
}

function SvgCheckBoxOutlineBlank(props) {
    return (React.createElement("svg", __assign({ xmlns: "http://www.w3.org/2000/svg", height: "1em", viewBox: "0 0 24 24", width: "1em" }, props),
        React.createElement("path", { d: "M0 0h24v24H0V0z", fill: "none" }),
        React.createElement("path", { d: "M19 5v14H5V5h14m0-2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2z" })));
}

function SvgRadioButtonChecked(props) {
    return (React.createElement("svg", __assign({ xmlns: "http://www.w3.org/2000/svg", height: "1em", viewBox: "0 0 24 24", width: "1em" }, props),
        React.createElement("path", { d: "M0 0h24v24H0V0z", fill: "none" }),
        React.createElement("path", { d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z" }),
        React.createElement("circle", { cx: 12, cy: 12, r: 5 })));
}

function SvgRadioButtonUnchecked(props) {
    return (React.createElement("svg", __assign({ xmlns: "http://www.w3.org/2000/svg", height: "1em", viewBox: "0 0 24 24", width: "1em" }, props),
        React.createElement("path", { d: "M0 0h24v24H0V0z", fill: "none" }),
        React.createElement("path", { d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z" })));
}

var ListItem = function (_a) {
    var _b;
    var variant = _a.variant, className = _a.className, alignTop = _a.alignTop, icon = _a.icon, checked = _a.checked, radio = _a.radio, primary = _a.primary, secondary = _a.secondary, inset = _a.inset, selected = _a.selected, compact = _a.compact, expanded = _a.expanded, disabled = _a.disabled, caretPosition = _a.caretPosition, controls = _a.controls, expandCommand = _a.expandCommand, onClick = _a.onClick, onTitleClick = _a.onTitleClick, children = _a.children, props = __rest(_a, ["variant", "className", "alignTop", "icon", "checked", "radio", "primary", "secondary", "inset", "selected", "compact", "expanded", "disabled", "caretPosition", "controls", "expandCommand", "onClick", "onTitleClick", "children"]);
    if (!caretPosition)
        caretPosition = "end";
    var _c = useState(expanded), isExpanded = _c[0], setIsExpanded = _c[1];
    useEffect(function () {
        if ((expandCommand === null || expandCommand === void 0 ? void 0 : expandCommand.expandAll) == true) {
            if (!isExpanded)
                setIsExpanded(true);
        }
        else if ((expandCommand === null || expandCommand === void 0 ? void 0 : expandCommand.collapseAll) == true) {
            if (!!isExpanded)
                setIsExpanded(false);
        }
    }, [expandCommand]);
    var cn = classNames("bd-list-item", className, {
        "bd-list-menu": variant === "menu",
        "bd-list-button": variant === "button",
        "bd-list-inset": inset,
        "bd-list-selected": selected,
        "bd-list-align-top": alignTop,
    });
    var clickHandler = function (e) {
        if (onClick) {
            if (onClick(e) === false)
                return false;
        }
        if (variant === "text")
            return null;
        if (disabled)
            return;
        setIsExpanded(!isExpanded);
    };
    if (checked === true)
        icon = radio ? React__default.createElement(SvgRadioButtonChecked, { className: "text-primary" }) : React__default.createElement(SvgCheckBox, { className: "text-primary" });
    if (checked === false)
        icon = radio ? React__default.createElement(SvgRadioButtonUnchecked, null) : React__default.createElement(SvgCheckBoxOutlineBlank, null);
    if (children && children.length > 0) {
        if (((_b = children[0]) === null || _b === void 0 ? void 0 : _b.type) !== List)
            children = React__default.createElement(List, null, children);
    }
    var RenderIcon = function () {
        if (typeof icon === "function")
            return icon(isExpanded);
        return icon;
    };
    return (React__default.createElement("li", __assign({ className: cn }, props),
        React__default.createElement(Toolbar, { size: compact ? "sm" : "md", onClick: clickHandler, className: classNames({ disabled: disabled }) },
            !!children && caretPosition == "start" && (React__default.createElement("span", { className: "m-e-2" },
                React__default.createElement(SvgChevronRight, { className: classNames("transition-transform", {
                        "rotate-90": isExpanded,
                        "rtl-rotate-180": !isExpanded,
                    }) }))),
            icon && React__default.createElement("div", { className: "bd-list-icon bd-list-py" }, RenderIcon()),
            React__default.createElement("div", { className: "bd-list-label", onClick: onTitleClick },
                React__default.createElement("div", null, primary),
                secondary && React__default.createElement("div", { className: "text-secondary-text" }, secondary)),
            controls,
            !!children && caretPosition == "end" && (React__default.createElement("span", { className: "" },
                React__default.createElement(SvgChevronRight, { className: classNames("transition-transform", {
                        "rotate-90": isExpanded,
                        "rtl-rotate-180": !isExpanded,
                    }) })))),
        children && (React__default.createElement(Collapse, { in: isExpanded },
            React__default.createElement("div", null, children)))));
};

var List = function (_a) {
    var header = _a.header, compact = _a.compact, small = _a.small, className = _a.className, variant = _a.variant, caretPosition = _a.caretPosition, children = _a.children, props = __rest(_a, ["header", "compact", "small", "className", "variant", "caretPosition", "children"]);
    var cn = classNames("bd-list", className, {
        "bd-compact": compact,
        "size-sm": small,
    });
    var MapChildren = function (children) {
        return React__default.Children.map(children, function (child) {
            var _a, _b;
            if (!React__default.isValidElement(child))
                return child;
            var x = child;
            if ((x === null || x === void 0 ? void 0 : x.type) === ListDivider)
                return React__default.createElement("li", { className: "bd-list-divider" });
            if ((x === null || x === void 0 ? void 0 : x.type) === List || (x === null || x === void 0 ? void 0 : x.type) === ListItem) {
                var newProps = __assign(__assign({ variant: variant, compact: compact, caretPosition: caretPosition }, child.props), { children: MapChildren((_a = child.props) === null || _a === void 0 ? void 0 : _a.children) });
                return React__default.cloneElement(child, newProps);
            }
            return !((_b = child.props) === null || _b === void 0 ? void 0 : _b.children)
                ? child
                : React__default.cloneElement(child, __assign(__assign({}, child.props), { children: MapChildren(child.props.children) }));
        });
    };
    return (React__default.createElement("ul", __assign({ className: cn }, props),
        header && React__default.createElement("li", { className: "bd-list-header" }, header),
        MapChildren(children)));
};

var Menu = function (_a) {
    var className = _a.className, children = _a.children, _b = _a.dropdown, dropdown = _b === void 0 ? true : _b, _c = _a.filterable, filterable = _c === void 0 ? false : _c, _d = _a.nothingFoundMessage, nothingFoundMessage = _d === void 0 ? "Nothing Found" : _d, _e = _a.searchMessage, searchMessage = _e === void 0 ? "Search" : _e, props = __rest(_a, ["className", "children", "dropdown", "filterable", "nothingFoundMessage", "searchMessage"]);
    var _f = useState(""), value = _f[0], setValue = _f[1];
    if (dropdown === undefined || dropdown === null)
        dropdown = true;
    if (dropdown) {
        var dropdownProps = {
            className: !className ? "shadow-4 border-0" : className,
        };
        if (!filterable) {
            return React__default.createElement(Dropdown.Menu, __assign({}, dropdownProps), children);
        }
        else {
            var v = value ? value.toLowerCase() : null;
            var items = React__default.Children.toArray(children).filter(function (x) { return isMatch(x, v); });
            return (React__default.createElement(Dropdown.Menu, __assign({}, dropdownProps, props),
                React__default.createElement(FormControl, { autoFocus: true, className: "mx-3 my-2 w-auto", placeholder: searchMessage, onChange: function (e) { return setValue(e.target.value); }, value: value }),
                items.length == 0 && (React__default.createElement("div", { className: "p-3", style: { opacity: 0.5 } }, nothingFoundMessage)),
                items));
        }
    }
    else {
        return React__default.createElement(React__default.Fragment, null);
    }
};
var MenuHeader = function (_a) {
    var props = __rest(_a, []);
    return React__default.createElement(Dropdown.Header, __assign({}, props), props.children);
};
var MenuDivider = function () {
    return React__default.createElement("div", { className: "dropdown-divider" });
};
var MenuItem = function (_a) {
    var props = __rest(_a, []);
    return React__default.createElement(Dropdown.Item, __assign({}, props), props.children);
};
var SubMenu = function (_a) {
    var menu = _a.menu, _b = _a.className, className = _b === void 0 ? "" : _b, props = __rest(_a, ["menu", "className"]);
    var cn = className + (className ? " " : "") + "dropdown-item";
    return (React__default.createElement(Dropdown, __assign({ as: "div" }, props, { className: "dropdown-submenu" }),
        React__default.createElement(Dropdown.Toggle, { as: "button", className: cn }, props.children),
        menu));
};
var isMatch = function (elem, value) {
    var children = elem.props.children;
    if (!children || !value)
        return true;
    if (typeof children === "string") {
        return children.toLowerCase().indexOf(value) >= 0;
    }
    return React__default.Children.toArray(children).filter(function (child) { return isMatch(child, value); });
};

var MsgBox = /** @class */ (function (_super) {
    __extends(MsgBox, _super);
    function MsgBox(props) {
        var _this = _super.call(this, props) || this;
        _this.renderBody = function () {
            if (!_this.props.body)
                return null;
            if (typeof _this.props.body === "function") {
                return _this.props.body(_this.onHideHandler);
            }
            return _this.props.body;
        };
        _this.renderButtons = function () {
            if (!_this.props.buttons)
                return null;
            if (typeof _this.props.buttons === "function") {
                return _this.props.buttons(_this.onHideHandler);
            }
            return React__default.createElement(React__default.Fragment, null, _this.props.buttons);
        };
        _this.onHideHandler = function () {
            _this.setState({ open: false });
            _this.props.onClose();
        };
        _this.state = { open: true };
        return _this;
    }
    MsgBox.prototype.render = function () {
        return (React__default.createElement(React__default.Fragment, null,
            React__default.createElement(Modal, { show: this.state.open, onHide: this.onHideHandler, size: this.props.size, backdropClassName: this.props.backdropClassName, className: this.props.className, dialogClassName: this.props.dialogClassName, contentClassName: this.props.contentClassName, fullscreen: this.props.fullscreen },
                this.props.title && (React__default.createElement(Modal.Header, { className: "p-4 pb-0 mb-n2" },
                    React__default.createElement(Modal.Title, { className: "h5" }, this.props.title))),
                React__default.createElement(Modal.Body, { className: "p-4" },
                    this.props.body && React__default.createElement("div", { className: "text-secondary-text" }, this.renderBody()),
                    this.props.buttons && React__default.createElement("div", { className: "pt-4 mb-n2 text-end" }, this.renderButtons())))));
    };
    return MsgBox;
}(React__default.Component));

var msgBoxList = [];
var msgbox = function (title, body, buttons, props) {
    if (msgBoxList.length > 0)
        msgBoxList[0].show(title, body, buttons, props);
};
var MsgBoxContainer = /** @class */ (function (_super) {
    __extends(MsgBoxContainer, _super);
    function MsgBoxContainer(props) {
        var _this = _super.call(this, props) || this;
        _this.handleClose = function (key) {
            var item = _this.state.list.find(function (item) { return item.key === key; });
            if (item) {
                setTimeout(function () {
                    var new_list = _this.state.list.filter(function (x) { return x !== item; });
                    _this.setState({ list: new_list });
                }, 1000);
            }
        };
        _this.show = function (title, body, buttons, props) {
            var id = "m-" + Date.now();
            if (typeof buttons === "string") {
                var btn_title = buttons;
                buttons = function (hide) { return (React__default.createElement(Button, { variant: "text", color: "primary", onClick: hide }, btn_title)); };
            }
            if (Array.isArray(buttons)) {
                var a = buttons;
                buttons = function (hide) { return (React__default.createElement(Flex, { content: "end", align: "center", gap: 1 }, a.map(function (x, xIndex) {
                    var _a, _b;
                    return (React__default.createElement(Button, { key: xIndex, variant: (_a = x.variant) !== null && _a !== void 0 ? _a : "text", color: (_b = x.color) !== null && _b !== void 0 ? _b : "primary", className: x.className, onClick: function () { return (!x.action ? hide() : x.action(hide)); } }, x.title));
                }))); };
            }
            var m = (React__default.createElement(MsgBox, { key: id, onClose: function () { return _this.handleClose(id); }, title: title, body: body, buttons: buttons, backdropClassName: props === null || props === void 0 ? void 0 : props.backdropClassName, className: props === null || props === void 0 ? void 0 : props.className }));
            _this.setState({ list: __spreadArray(__spreadArray([], _this.state.list, true), [m], false) });
        };
        _this.state = { list: [] };
        return _this;
    }
    MsgBoxContainer.prototype.componentDidMount = function () {
        msgBoxList.push(this);
    };
    MsgBoxContainer.prototype.componentWillUnmount = function () {
        var index = msgBoxList.indexOf(this);
        if (index > -1) {
            msgBoxList.splice(index, 1);
        }
    };
    MsgBoxContainer.prototype.render = function () {
        return this.state.list.map(function (x) { return x; });
    };
    return MsgBoxContainer;
}(React__default.Component));

var Panel = function (_a) {
    var variant = _a.variant, className = _a.className, title = _a.title, headerClassName = _a.headerClassName, titleClassName = _a.titleClassName, caretPosition = _a.caretPosition, size = _a.size, fixed = _a.fixed, expanded = _a.expanded, disabled = _a.disabled, controls = _a.controls, lazyload = _a.lazyload, onToggle = _a.onToggle, children = _a.children, props = __rest(_a, ["variant", "className", "title", "headerClassName", "titleClassName", "caretPosition", "size", "fixed", "expanded", "disabled", "controls", "lazyload", "onToggle", "children"]);
    var _b = useState({ isExpanded: expanded, render: expanded || !lazyload }), panelState = _b[0], setPanelState = _b[1];
    var cn = classNames("bd-panel", className, {
        "bd-panel-menu": variant === "menu",
    });
    var toggle = function (caret) {
        var just_caret = variant !== "button" && variant !== "menu";
        if ((caret && !just_caret) || (!caret && just_caret))
            return null;
        if (disabled || fixed)
            return;
        var isExpanded = !panelState.isExpanded;
        setPanelState({ isExpanded: isExpanded, render: true });
        if (onToggle)
            onToggle(isExpanded);
    };
    function renderHandler(position) {
        var show = (!caretPosition && position === "start") || caretPosition === position;
        if (fixed || !children || !show)
            return null;
        return (React__default.createElement("span", { className: classNames("px-2 py-1", {
                "cur-pointer": !disabled,
                "edge-start": position === "start",
                "edge-end": position === "end",
            }), onClick: function () { return toggle(true); } },
            React__default.createElement(SvgChevronRight, { className: classNames("transition-transform", {
                    "rotate-90": panelState.isExpanded,
                    "rtl-rotate-180": !panelState.isExpanded,
                }) })));
    }
    return (React__default.createElement("div", __assign({ className: cn }, props),
        React__default.createElement(Toolbar, { size: size, onClick: function () { return toggle(false); }, className: classNames(headerClassName, {
                "cur-pointer": variant === "button" || variant === "menu",
                disabled: disabled,
            }) },
            renderHandler("start"),
            React__default.createElement("h5", { className: classNames("d-flex", titleClassName, { "flex-grow-1": caretPosition !== "middle" }) }, title),
            renderHandler("middle"),
            controls != null && React__default.createElement("div", { className: "m-s-auto" }),
            controls,
            renderHandler("end")),
        children && (React__default.createElement(Collapse, { in: panelState.isExpanded },
            React__default.createElement("div", null, panelState.render && children)))));
};

var Paper = function (_a) {
    var _b;
    var className = _a.className, _c = _a.shadow, shadow = _c === void 0 ? 1 : _c, _d = _a.outline, outline = _d === void 0 ? false : _d, _e = _a.square, square = _e === void 0 ? false : _e, children = _a.children, props = __rest(_a, ["className", "shadow", "outline", "square", "children"]);
    var cn = classNames("paper", className, outline, (_b = {},
        _b["shadow-".concat(shadow)] = !outline && shadow >= 0 && shadow <= 24,
        _b["paper-outline"] = outline,
        _b["paper-rounded"] = !square,
        _b));
    return (React__default.createElement("div", __assign({ className: cn }, props), children));
};
/*
Paper.propTypes = {
    className: PropTypes.string,
    shadow: PropTypes.number,
    outline: PropTypes.bool,
    square: PropTypes.bool,
};*/

var ScrollPane = function (_a) {
    var as = _a.as, vertical = _a.vertical, className = _a.className, containerClassName = _a.containerClassName, prevButton = _a.prevButton, nextButton = _a.nextButton, _b = _a.mouseWheel, mouseWheel = _b === void 0 ? true : _b, children = _a.children, onWheel = _a.onWheel, onScroll = _a.onScroll, getApiRef = _a.getApiRef, props = __rest(_a, ["as", "vertical", "className", "containerClassName", "prevButton", "nextButton", "mouseWheel", "children", "onWheel", "onScroll", "getApiRef"]);
    if (getApiRef)
        getApiRef.current = getApi;
    var transition = new Transition("easeOutQuart", 300);
    var ref = useRef(null);
    var isRtl = function () {
        if (vertical)
            return false;
        var elem = ref.current;
        var v = window.getComputedStyle ? window.getComputedStyle(elem, null).getPropertyValue("direction") : elem.currentStyle.direction;
        return v === "rtl";
    };
    var getScrollPos = function () { return (vertical ? ref.current.scrollTop : (isRtl() ? -1 : 1) * ref.current.scrollLeft); };
    var getScrollSize = function () { return (vertical ? ref.current.scrollHeight : ref.current.scrollWidth); };
    var getViewportSize = function () { return (vertical ? ref.current.clientHeight : ref.current.clientWidth); };
    var setScrollPos = function (v) {
        if (vertical)
            ref.current.scrollTop = v;
        else
            ref.current.scrollLeft = isRtl() ? -v : v;
    };
    var scrollTo = function (elem) {
        var sign = isRtl() ? -1 : 1;
        var D = 40;
        var v1 = vertical ? ref.current.scrollTop : ref.current.scrollLeft;
        var v2 = v1 + getViewportSize();
        var e1 = vertical ? elem.offsetTop : elem.offsetLeft;
        var e2 = e1 + (vertical ? elem.clientHeight : elem.clientWidth);
        var delta = 0;
        if (e2 + D > v2)
            delta = v2 - e2 - D;
        if (e1 + delta - D < v1)
            delta += v1 - e1 + D;
        if (delta !== 0)
            scroll(-delta * sign);
    };
    var scroll = function (delta) {
        if (Math.abs(delta) < 1)
            delta = delta * getViewportSize();
        var curr = getScrollPos();
        var pos = (transition.busy ? transition.endPos : curr) + delta;
        pos = Math.max(0, Math.min(pos, getScrollSize() - getViewportSize()));
        transition.start(curr, pos, function (value) { return setScrollPos(value); });
    };
    var _c = useState(false), canGoPrev = _c[0], setCanGoPrev = _c[1];
    var _d = useState(false), canGoNext = _d[0], setCanGoNext = _d[1];
    var updatePromise = null;
    function updateButtonState() {
        if (updatePromise) {
            return;
        }
        updatePromise = new Promise(function (resolve) { return resolve(null); });
        updatePromise.then(function () {
            updatePromise = null;
            var _prev = ref.current && getScrollPos() > 0;
            var _next = ref.current && getScrollPos() < getScrollSize() - getViewportSize();
            if (_prev === canGoPrev && _next === canGoNext)
                return;
            canGoPrev = _prev;
            canGoNext = _next;
            setCanGoPrev(_prev);
            setCanGoNext(_next);
        });
    }
    var handleOnWheel = function (ev) {
        updateButtonState();
        if (onWheel)
            return onWheel(ev);
        if (!mouseWheel || vertical)
            return false;
        //ev.preventDefault();
        var delta = Math.min(150, getViewportSize() / 2);
        scroll(ev.deltaY > 0 ? delta : -delta);
    };
    var handleOnScroll = function (ev) {
        updateButtonState();
        if (onScroll)
            onScroll(ev);
    };
    useEffect(function () {
        updateButtonState();
    }, [ref]);
    var onResize = function (w, h) {
        updateButtonState();
    };
    function getApi() {
        return { canGoPrev: canGoPrev, canGoNext: canGoNext, scroll: scroll, scrollTo: scrollTo, isRtl: isRtl };
    }
    return (React__default.createElement("div", __assign({ className: classNames("scroll-pane", className, {
            "scroll-pane-vertical": vertical,
            "scroll-pane-horizontal": !vertical,
        }) }, props),
        prevButton && prevButton({ canGoPrev: canGoPrev, canGoNext: canGoNext, scroll: scroll, scrollTo: scrollTo, isRtl: isRtl }),
        React__default.createElement(ResizeWatch, { as: as, dimension: vertical ? "height" : "width", className: classNames("scroll-pane-container", containerClassName), ref: ref, onWheel: handleOnWheel, onScroll: handleOnScroll, onResize: onResize }, children),
        nextButton && nextButton({ canGoPrev: canGoPrev, canGoNext: canGoNext, scroll: scroll, scrollTo: scrollTo, isRtl: isRtl })));
};

var Switch = function (_a) {
    var id = _a.id, className = _a.className, label = _a.label, _b = _a.labelClassName, labelClassName = _b === void 0 ? "" : _b, labelStyle = _a.labelStyle, color = _a.color, size = _a.size, disabled = _a.disabled, model = _a.model, edge = _a.edge, compact = _a.compact, labelPlacement = _a.labelPlacement, onChange = _a.onChange, onFocus = _a.onFocus, onBlur = _a.onBlur, onMouseLeave = _a.onMouseLeave, onMouseDown = _a.onMouseDown, setModel = _a.setModel, props = __rest(_a, ["id", "className", "label", "labelClassName", "labelStyle", "color", "size", "disabled", "model", "edge", "compact", "labelPlacement", "onChange", "onFocus", "onBlur", "onMouseLeave", "onMouseDown", "setModel"]);
    if (!color)
        color = "primary";
    if (!labelPlacement)
        labelPlacement = "end";
    var cn = classNames(className, "switch", {
        "switch-primary": color === "primary",
        "switch-secondary": color === "secondary",
        "switch-default": color === "default",
        "switch-sm": size === "sm",
        "edge-start": edge === "start",
        "edge-end": edge === "end",
        "bd-compact": compact,
        disabled: disabled,
    });
    var getThumb = function (switchElem) { return switchElem.getElementsByClassName("switch-thumb")[0]; };
    var inputProps;
    inputProps = { checked: model !== null && model !== void 0 ? model : false, onChange: onChangeHandler };
    if (disabled)
        inputProps = __assign(__assign({}, inputProps), { disabled: disabled });
    inputProps = __assign(__assign({}, inputProps), { onFocus: function (e) {
            var thumbElem = getThumb(e.currentTarget.parentNode);
            ripple.focus(thumbElem);
            if (onFocus)
                onFocus(e);
        }, onBlur: function (e) {
            var thumbElem = getThumb(e.currentTarget.parentNode);
            ripple.blur(thumbElem);
            if (onBlur)
                onBlur(e);
        } });
    var rippleProps = {
        onMouseLeave: function (e) {
            var thumbElem = getThumb(e.currentTarget);
            ripple.removeFocus(thumbElem);
            if (onMouseLeave)
                onMouseLeave(e);
        },
        onMouseDown: function (e) {
            var thumbElem = getThumb(e.currentTarget);
            ripple.pulse(thumbElem, 0, 0);
            if (onMouseDown)
                onMouseDown(e);
        },
        //onMouseMove: focusBorderRipple.hide,
        //onMouseUp: focusBorderRipple.hide,
    };
    function onChangeHandler(e) {
        if (setModel)
            setModel(e.target.checked);
        if (onChange)
            onChange(e);
    }
    function renderSwitch() {
        return (React__default.createElement("span", __assign({ className: cn }, props, rippleProps),
            React__default.createElement("input", __assign({ id: id, type: "checkbox" }, inputProps)),
            React__default.createElement("span", { className: "switch-track" }),
            React__default.createElement("span", { className: "switch-thumb" })));
    }
    return (React__default.createElement("label", { className: classNames("switch-label", labelClassName, { "text-secondary-text": disabled }), style: labelStyle },
        labelPlacement === "start" && label,
        renderSwitch(),
        labelPlacement === "end" && label));
};

function SvgIndeterminateCheckBox(props) {
    return (React.createElement("svg", __assign({ xmlns: "http://www.w3.org/2000/svg", height: "1em", viewBox: "0 0 24 24", width: "1em" }, props),
        React.createElement("path", { d: "M0 0h24v24H0z", fill: "none" }),
        React.createElement("path", { d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H5V5h14v14zM7 11h10v2H7z" })));
}

function SvgChevronLeft(props) {
    return (React.createElement("svg", __assign({ xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", viewBox: "0 0 24 24" }, props),
        React.createElement("path", { d: "M15.41 7.41L14 6l-6 6 6 6 1.41-1.41L10.83 12l4.58-4.59z" })));
}

var TabStrip = function (_a) {
    var shade = _a.shade, variant = _a.variant, scrollButtons = _a.scrollButtons, _b = _a.mouseWheel, mouseWheel = _b === void 0 ? false : _b, indicator = _a.indicator, indicatorColor = _a.indicatorColor, textColor = _a.textColor, className = _a.className, children = _a.children, props = __rest(_a, ["shade", "variant", "scrollButtons", "mouseWheel", "indicator", "indicatorColor", "textColor", "className", "children"]);
    if (!textColor)
        textColor = "primary";
    if (!indicatorColor)
        indicatorColor = textColor;
    var cn = classNames("tabstrip", className, {
        "tabstrip-fixed": variant === "fixed",
        "tabstrip-centered": variant === "centered",
        "tabstrip-full-width": variant === "fullWidth",
        "tabstrip-indicator-none": indicator === "none",
        "tabstrip-indicator-reverse": indicator === "reverse",
        "tabstrip-indicator-all": indicator === "all",
        "tabstrip-indicator-default": indicatorColor === "default",
        "tabstrip-indicator-primary": indicatorColor === "primary",
        "tabstrip-indicator-secondary": indicatorColor === "secondary",
        "tabstrip-text-primary": textColor === "primary",
        "tabstrip-text-secondary": textColor === "secondary",
        "tabstrip-shade": shade === true || shade === "default",
        "tabstrip-shade-primary": shade === "primary",
        "tabstrip-shade-secondary": shade === "secondary",
    });
    var is_vertical = variant === "vertical";
    var getApiRef = React__default.createRef();
    var scrollButtonsAreAuto = !scrollButtons || scrollButtons === "auto" || scrollButtons === "desktop";
    var scrollButtonsAreVisible = function (api) {
        return scrollButtons === "on" || scrollButtons === "desktop" || (scrollButtonsAreAuto && (api.canGoPrev || api.canGoNext));
    };
    var getApi = function () { var _a; return (_a = getApiRef.current) === null || _a === void 0 ? void 0 : _a.call(getApiRef); };
    var getPrevButton = function (api) {
        return scrollButtonsAreVisible(api) && (React__default.createElement(Button, { variant: "text", color: "inherit", size: "sm", disabled: !api.canGoPrev, className: classNames("tabstrip-scroll-button", { "tabstrip-sm-hide-scroll-button": scrollButtons === "desktop" }), onClick: function () { return api.scroll(-0.5); } },
            React__default.createElement(SvgChevronLeft, { className: "rtl-rotate-180" })));
    };
    var getNextButton = function (api) {
        return scrollButtonsAreVisible(api) && (React__default.createElement(React__default.Fragment, null,
            React__default.createElement(Button, { variant: "text", color: "inherit", size: "sm", disabled: !api.canGoNext, className: classNames("tabstrip-scroll-button", { "tabstrip-sm-hide-scroll-button": scrollButtons === "desktop" }), onClick: function () { return api.scroll(0.5); } },
                React__default.createElement(SvgChevronRight, { className: "rtl-rotate-180" }))));
    };
    var scrollTo = function (elem) { return getApi().scrollTo(elem); };
    var MapChildren = function (children) {
        return React__default.Children.map(children, function (child) {
            var _a, _b;
            if (!child || !React__default.isValidElement(child))
                return child;
            var x = child;
            if (x.type === TabStripItem)
                return React__default.cloneElement(child, { scrollTo: scrollTo });
            if (!((_a = child.props) === null || _a === void 0 ? void 0 : _a.children))
                return child;
            return React__default.cloneElement(child, { children: MapChildren((_b = child.props) === null || _b === void 0 ? void 0 : _b.children) });
        });
    };
    return (React__default.createElement(ScrollPane, __assign({ vertical: is_vertical, as: Nav, className: cn }, props, { getApiRef: getApiRef, mouseWheel: mouseWheel, prevButton: getPrevButton, nextButton: getNextButton }), MapChildren(children)));
};

var TabStripItem = function (_a) {
    var eventKey = _a.eventKey, wrapped = _a.wrapped, className = _a.className, onClick = _a.onClick, scrollTo = _a.scrollTo, children = _a.children, props = __rest(_a, ["eventKey", "wrapped", "className", "onClick", "scrollTo", "children"]);
    var ref = React__default.useRef();
    var handleOnClick = function (e) {
        if (scrollTo)
            scrollTo(ref.current);
        else
            console.log("!scrollTo");
        if (onClick)
            onClick(e);
    };
    return (React__default.createElement(Nav.Link, __assign({}, props, { eventKey: eventKey, onClick: handleOnClick, ref: ref, className: classNames(className, { "toolstrip-item-wrapped": wrapped }) }), children));
};

function SvgDragIndicator(props) {
    return (React.createElement("svg", __assign({ xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", viewBox: "0 0 24 24" }, props),
        React.createElement("path", { d: "M11 18c0 1.1-.9 2-2 2s-2-.9-2-2 .9-2 2-2 2 .9 2 2zm-2-8c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0-6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm6 4c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zm0 2c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0 6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2z" })));
}

function SvgSubdirectoryArrowLeft(props) {
    return (React.createElement("svg", __assign({ xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", viewBox: "0 0 24 24" }, props),
        React.createElement("path", { d: "M11 9l1.42 1.42L8.83 14H18V4h2v12H8.83l3.59 3.58L11 21l-6-6 6-6z" })));
}

function SvgSubdirectoryArrowRight(props) {
    return (React.createElement("svg", __assign({ xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", viewBox: "0 0 24 24" }, props),
        React.createElement("path", { d: "M19 15l-6 6-1.42-1.42L15.17 16H4V4h2v10h9.17l-3.59-3.58L13 9l6 6z" })));
}

var BasicTable = function (_a) {
    var hover = _a.hover, striped = _a.striped, compact = _a.compact, nowrap = _a.nowrap, fixed = _a.fixed, columns = _a.columns, data = _a.data, selectedIndices = _a.selectedIndices, multiSelect = _a.multiSelect, singleSelect = _a.singleSelect, hideCheckbox = _a.hideCheckbox, draggable = _a.draggable, disableToggleOnClick = _a.disableToggleOnClick, className = _a.className, style = _a.style, maxHeight = _a.maxHeight, maxWidth = _a.maxWidth, children = _a.children, actions = _a.actions, hideHeader = _a.hideHeader, 
    //renderCell is depriciated
    renderCell = _a.renderCell, 
    //renderTD is depriciated
    renderTD = _a.renderTD, onSelectionChanged = _a.onSelectionChanged, onDragStart = _a.onDragStart, onDragEnd = _a.onDragEnd, onCanDrop = _a.onCanDrop, onDrop = _a.onDrop, cellCSS = _a.cellCSS, headerCSS = _a.headerCSS, onRowClick = _a.onRowClick, onRowDoubleClick = _a.onRowDoubleClick, props = __rest(_a, ["hover", "striped", "compact", "nowrap", "fixed", "columns", "data", "selectedIndices", "multiSelect", "singleSelect", "hideCheckbox", "draggable", "disableToggleOnClick", "className", "style", "maxHeight", "maxWidth", "children", "actions", "hideHeader", "renderCell", "renderTD", "onSelectionChanged", "onDragStart", "onDragEnd", "onCanDrop", "onDrop", "cellCSS", "headerCSS", "onRowClick", "onRowDoubleClick"]);
    if (multiSelect)
        singleSelect = false;
    var dragStartRowIndex = React__default.useRef();
    var cn = classNames("bd-table", className, {
        "bd-table-full-width": !fixed,
        "bd-table-hover": hover,
        "bd-table-striped": striped,
        "bd-table-compact": compact,
        "bd-table-nowrap": nowrap,
        "bd-table-fixed": fixed,
        "cur-pointer": (singleSelect || multiSelect) && !disableToggleOnClick,
    });
    var isSelected = function (idx) { return selectedIndices && selectedIndices.some(function (x) { return x === idx; }); };
    var toggleSelection = function (idx, isDoubleClick) {
        if (!onSelectionChanged)
            return;
        var list = [];
        var is_selected = !isDoubleClick && isSelected(idx);
        if (singleSelect) {
            list = is_selected ? [] : [idx];
        }
        else {
            list = is_selected ? selectedIndices.filter(function (x) { return x !== idx; }) : __spreadArray(__spreadArray([], selectedIndices, true), [idx], false);
        }
        onSelectionChanged(list, idx);
    };
    var toggleAllSelection = function () {
        if (!onSelectionChanged)
            return;
        var list = [];
        if (selectedIndices.length < data.length)
            for (var i = 0; i < data.length; i++) {
                list.push(i);
            }
        onSelectionChanged(list, null);
    };
    var handleRowClick = function (row, idx, event) {
        if (!disableToggleOnClick) {
            if (multiSelect || singleSelect)
                toggleSelection(idx, event.detail > 1);
        }
        onRowClick && onRowClick({ row: row, rowIndex: idx, event: event });
    };
    var handleCellClick = function (idx) {
        if (multiSelect || singleSelect)
            toggleSelection(idx, false);
    };
    var getHeaderCSS = function (_a) {
        var columnName = _a.columnName, columnIndex = _a.columnIndex;
        return headerCSS instanceof Function ? headerCSS({ columnName: columnName, columnIndex: columnIndex }) : headerCSS;
    };
    var getCellCSS = function (args) {
        return cellCSS instanceof Function ? cellCSS(args) : cellCSS;
    };
    var getTHProps = function (c, columnIndex) {
        var _a, _b;
        var p = { style: { width: c.width, minWidth: (_a = c.minWidth) !== null && _a !== void 0 ? _a : c.width } };
        var args = { columnName: (_b = c.name) !== null && _b !== void 0 ? _b : c.accessor, columnIndex: columnIndex };
        var css = getHeaderCSS(args);
        var css_column = c.headerCSS instanceof Function ? c.headerCSS(args) : c.headerCSS;
        return __assign(__assign({}, p), { className: classNames(css, css_column) });
    };
    var getTDProps = function (row, rowIndex, c, columnIndex) {
        var _a;
        var args = { row: row, rowIndex: rowIndex, columnName: (_a = c.name) !== null && _a !== void 0 ? _a : c.accessor, columnIndex: columnIndex };
        var css = getCellCSS(args);
        var css_column = c.cellCSS instanceof Function ? c.cellCSS(args) : c.cellCSS;
        var p = { className: classNames(css, css_column) };
        if (hideHeader)
            p["style"] = { width: c.width, minWidth: c.width };
        return p;
    };
    var onDragStartHandler = function (ev, rowIndex) {
        ev.dataTransfer.effectAllowed = "move";
        dragStartRowIndex.current = rowIndex;
        ev.dataTransfer.setDragImage(new Image(), 0, 0);
        onDragStart && onDragStart(ev, rowIndex);
    };
    var onDragEndHandler = function (ev, rowIndex) {
        onDragEnd && onDragEnd(ev, rowIndex);
    };
    var onDragOverHandler = function (ev, newRowIndex, newColumnIndex) {
        var idx = dragStartRowIndex.current;
        if (onCanDrop && onCanDrop(ev, idx, newRowIndex, newColumnIndex))
            ev.preventDefault();
    };
    var onDropHandler = function (ev, newRowIndex, newColumnIndex) {
        var idx = dragStartRowIndex.current;
        onDrop && onDrop(ev, idx, newRowIndex, newColumnIndex);
        ev.preventDefault();
    };
    var getDisplayValue = function (row, columnName, rowIndex, columnIndex) {
        var col = columns[columnIndex];
        var value = !row || !columnName ? null : row[columnName];
        if (col.getDisplayValue)
            return col.getDisplayValue({ value: value, row: row, columnName: columnName, rowIndex: rowIndex, columnIndex: columnIndex });
        if (col.Cell)
            return col.Cell({ value: value, row: row, columnName: columnName, rowIndex: rowIndex, columnIndex: columnIndex });
        // renderCell is depriciated
        return renderCell ? renderCell({ row: row, columnName: columnName, rowIndex: rowIndex, columnIndex: columnIndex, value: value }) : value;
    };
    var renderHandler = function (row, rowIndex, column, columnIndex) {
        var _a;
        var col = columns[columnIndex];
        var col_name = (_a = col.name) !== null && _a !== void 0 ? _a : col.accessor;
        var onClick = function (event) {
            if (col.onCellClick && event.detail == 1)
                col.onCellClick({ row: row, rowIndex: rowIndex, columnName: col_name, columnIndex: columnIndex, event: event });
        };
        var onDoubleClick = function (event) {
            if (col.onCellDoubleClick)
                col.onCellDoubleClick({ row: row, rowIndex: rowIndex, columnName: col_name, columnIndex: columnIndex, event: event });
        };
        var defaultProps = __assign(__assign({}, getTDProps(row, rowIndex, column, columnIndex)), { key: rowIndex + "." + columnIndex, onDragOver: function (ev) { return onDragOverHandler(ev, rowIndex, columnIndex); }, onDragEnter: function (ev) { return onDragOverHandler(ev, rowIndex, columnIndex); }, onDrop: function (ev) { return onDropHandler(ev, rowIndex, columnIndex); }, onClick: onClick, onDoubleClick: onDoubleClick });
        var defaultGetDisplayValue = function () { return getDisplayValue(row, col_name, rowIndex, columnIndex); };
        if (col.render)
            return col.render({ row: row, columnName: col_name, rowIndex: rowIndex, columnIndex: columnIndex, defaultProps: defaultProps });
        //-------
        // depriciated
        if (renderTD) {
            var elem = renderTD({
                row: row,
                columnName: col_name,
                rowIndex: rowIndex,
                columnIndex: columnIndex,
                defaultProps: defaultProps,
                renderCell: defaultGetDisplayValue,
            });
            return elem !== null && elem !== void 0 ? elem : React__default.createElement(React__default.Fragment, { key: rowIndex + "." + columnIndex });
        }
        return React__default.createElement("td", __assign({}, defaultProps), defaultGetDisplayValue());
    };
    var canShowCheckBox = !hideCheckbox && (draggable || multiSelect || singleSelect);
    return (React__default.createElement(React__default.Fragment, null,
        React__default.createElement("div", __assign({ className: cn, style: __assign(__assign({}, style), { maxHeight: maxHeight, maxWidth: maxWidth }) }, props),
            data && data.length > 0 && (React__default.createElement("table", null,
                !hideHeader && (React__default.createElement("thead", null,
                    React__default.createElement("tr", null,
                        canShowCheckBox && (React__default.createElement("th", { className: classNames("selection-column", getHeaderCSS({ columnName: null, columnIndex: -1 })) }, multiSelect && (React__default.createElement(Toggle, { size: "sm", disableRipple: true, indeterminate: selectedIndices.length > 0 && selectedIndices.length < data.length, model: selectedIndices.length === data.length, setModel: toggleAllSelection })))),
                        columns.map(function (c, cIndex) {
                            var _a;
                            return (React__default.createElement("th", __assign({ key: cIndex }, getTHProps(c, cIndex)), (_a = c.title) !== null && _a !== void 0 ? _a : c.Header));
                        })))),
                React__default.createElement("tbody", null, data.map(function (row, rowIndex) { return (React__default.createElement("tr", { key: rowIndex, className: isSelected(rowIndex) ? "selected" : null, onClick: function (event) { return handleRowClick(row, rowIndex, event); }, onDoubleClick: function (event) { return onRowDoubleClick && onRowDoubleClick({ row: row, rowIndex: rowIndex, event: event }); } },
                    canShowCheckBox && (React__default.createElement("td", { onDragOver: function (ev) { return onDragOverHandler(ev, rowIndex, -1); }, onDragEnter: function (ev) { return onDragOverHandler(ev, rowIndex, -1); }, onDrop: function (ev) { return onDropHandler(ev, rowIndex, -2); }, className: classNames("cur-pointer", getCellCSS({ row: row, rowIndex: rowIndex, columnName: null, columnIndex: -1, value: null })), onClick: function () { return handleCellClick(rowIndex); } },
                        draggable && (React__default.createElement("span", { className: "cur-pointer", draggable: draggable, onDragStart: function (ev) { return onDragStartHandler(ev, rowIndex); }, onDragEnd: function (ev) { return onDragEndHandler(ev, rowIndex); } },
                            React__default.createElement(SvgDragIndicator, { className: "text-secondary-text" }))),
                        multiSelect && (React__default.createElement(Toggle, { size: "sm", disableRipple: true, model: isSelected(rowIndex), setModel: function () { return toggleSelection(rowIndex, false); } })),
                        singleSelect && (React__default.createElement(Toggle, { size: "sm", disableRipple: true, model: isSelected(rowIndex), setModel: function () { return toggleSelection(rowIndex, false); }, radio: true })))),
                    columns.map(function (c, columnIndex) { return renderHandler(row, rowIndex, c, columnIndex); }))); })))),
            (!data || data.length == 0) && children),
        actions && (React__default.createElement(Flex, { align: "center", className: "bg-shade-5 p-s-4 py-2 border-bottom", gap: 3 },
            React__default.createElement(SvgSubdirectoryArrowRight, { className: "rtl-d-none text-secondary-text" }),
            React__default.createElement(SvgSubdirectoryArrowLeft, { className: "ltr-d-none text-secondary-text" }),
            actions))));
};

var Toggle = function (_a) {
    var id = _a.id, name = _a.name, label = _a.label, _b = _a.labelClassName, labelClassName = _b === void 0 ? "" : _b, labelStyle = _a.labelStyle, textClassName = _a.textClassName, textStyle = _a.textStyle, radio = _a.radio, value = _a.value, model = _a.model, checked = _a.checked, checkedImage = _a.checkedImage, uncheckedImage = _a.uncheckedImage, disableRipple = _a.disableRipple, disabled = _a.disabled, readOnly = _a.readOnly, className = _a.className, color = _a.color, size = _a.size, edge = _a.edge, compact = _a.compact, labelPlacement = _a.labelPlacement, indeterminate = _a.indeterminate, indeterminateImage = _a.indeterminateImage, inputRef = _a.inputRef, defaultChecked = _a.defaultChecked, onChange = _a.onChange, setModel = _a.setModel, onMouseDown = _a.onMouseDown, onMouseLeave = _a.onMouseLeave, onFocus = _a.onFocus, onBlur = _a.onBlur, props = __rest(_a, ["id", "name", "label", "labelClassName", "labelStyle", "textClassName", "textStyle", "radio", "value", "model", "checked", "checkedImage", "uncheckedImage", "disableRipple", "disabled", "readOnly", "className", "color", "size", "edge", "compact", "labelPlacement", "indeterminate", "indeterminateImage", "inputRef", "defaultChecked", "onChange", "setModel", "onMouseDown", "onMouseLeave", "onFocus", "onBlur"]);
    if (!labelPlacement)
        labelPlacement = "end";
    if (color === "inherit")
        color = "";
    else if (!color)
        color = "primary";
    var cn = classNames(className, "toggle", {
        "toggle-primary": color === "primary",
        "toggle-secondary": color === "secondary",
        "toggle-sm": size === "sm",
        "toggle-md": size === "md",
        "toggle-lg": size === "lg",
        "toggle-xl": size === "xl",
        "edge-start": edge === "start",
        "edge-end": edge === "end",
        "bd-compact": compact,
        disabled: !!disabled,
    });
    var rippleProps = {
        onMouseLeave: function (e) {
            if (!disableRipple) {
                ripple.removeFocus(e.currentTarget);
            }
            if (onMouseLeave)
                onMouseLeave(e);
        },
        onMouseDown: function (e) {
            if (!disableRipple) {
                ripple.pulse(e.currentTarget, 0, 0);
            }
            if (onMouseDown)
                onMouseDown(e);
        },
    };
    var inputProps;
    inputProps = __assign({ ref: inputRef, defaultChecked: defaultChecked, type: radio ? "radio" : "checkbox", checked: checked, indeterminate: indeterminate ? "true" : "false", onChange: function (e) {
            if (onChange)
                onChange(e);
            if (setModel) {
                if (radio)
                    setModel(e.target.value);
                else
                    setModel(e.target.checked);
            }
        }, onFocus: function (e) {
            if (!disableRipple) {
                ripple.focus(e.currentTarget.parentNode);
            }
            if (onFocus)
                onFocus(e);
        }, onBlur: function (e) {
            if (!disableRipple) {
                ripple.blur(e.currentTarget.parentNode);
            }
            if (onBlur)
                onBlur(e);
        } }, props);
    if (disabled || readOnly)
        inputProps = __assign(__assign({}, inputProps), { disabled: true });
    if (model !== undefined) {
        var v = value === undefined ? true : value;
        inputProps = __assign(__assign({}, inputProps), { checked: model === v });
    }
    function renderText() {
        return (label && (React__default.createElement("span", { className: classNames("toggle-text", textClassName), style: textStyle }, label)));
    }
    function renderCheckbox() {
        var unchecked;
        if (indeterminate)
            unchecked = indeterminateImage ? indeterminateImage : React__default.createElement(SvgIndeterminateCheckBox, null);
        else if (uncheckedImage)
            unchecked = uncheckedImage;
        else
            unchecked = radio ? React__default.createElement(SvgRadioButtonUnchecked, null) : React__default.createElement(SvgCheckBoxOutlineBlank, null);
        return (React__default.createElement("span", __assign({ className: cn }, rippleProps),
            React__default.createElement("input", __assign({ id: id, name: name, value: value }, inputProps)),
            React__default.createElement("span", null, unchecked),
            React__default.createElement("span", null, !!checkedImage ? checkedImage : radio ? React__default.createElement(SvgRadioButtonChecked, null) : React__default.createElement(SvgCheckBox, null))));
    }
    return (React__default.createElement("label", { className: classNames("toggle-label", labelClassName, { "text-secondary-text": disabled, "disable-ripple": disableRipple }), style: labelStyle },
        labelPlacement === "start" && renderText(),
        renderCheckbox(),
        labelPlacement === "end" && renderText()));
};

var Toolbar = function (_a) {
    var className = _a.className, size = _a.size, gap = _a.gap, children = _a.children, props = __rest(_a, ["className", "size", "gap", "children"]);
    var cn = classNames(className, "toolbar", {
        "toolbar-sm": size === "sm",
        "toolbar-md": size === "md",
        "toolbar-lg": size === "lg",
        "gap-1": gap === 1,
        "gap-2": gap === 2,
        "gap-3": gap === 3,
        "gap-4": gap === 4,
        "gap-5": gap === 5,
    });
    return (React__default.createElement("div", __assign({ className: cn }, props), children));
};

var TreeViewDivider = function () { return null; };

var TreeViewItem = function (_a) {
    var _b;
    var id = _a.id, variant = _a.variant, className = _a.className, title = _a.title, selected = _a.selected, compact = _a.compact, expanded = _a.expanded, disabled = _a.disabled, focus = _a.focus, href = _a.href, lazyload = _a.lazyload, onToggleSelection = _a.onToggleSelection, onClick = _a.onClick, onTitleClick = _a.onTitleClick, children = _a.children, props = __rest(_a, ["id", "variant", "className", "title", "selected", "compact", "expanded", "disabled", "focus", "href", "lazyload", "onToggleSelection", "onClick", "onTitleClick", "children"]);
    if (!variant)
        variant = "menu";
    if (!href)
        href = "#";
    var _c = useState({ isExpanded: expanded, render: expanded || !lazyload }), treeviewState = _c[0], setTreeviewState = _c[1];
    var clickHandler = function (e) {
        e.preventDefault();
        if (onClick) {
            if (onClick(e) === false)
                return false;
        }
        if (variant === "text")
            return null;
        if (disabled)
            return false;
        if (!!children) {
            var isExpanded = !treeviewState.isExpanded;
            setTreeviewState({ isExpanded: isExpanded, render: true });
        }
        if (onToggleSelection)
            onToggleSelection(id);
        return false;
    };
    var onClickSpan = function (e) {
        if (disabled)
            return;
        if (variant === "text") {
            if (!!children) {
                var isExpanded = !treeviewState.isExpanded;
                setTreeviewState({ isExpanded: isExpanded, render: true });
            }
            if (onToggleSelection)
                onToggleSelection(id);
        }
    };
    var _children = children;
    if (!treeviewState.render) {
        if (!!_children)
            _children = React__default.createElement("div", null);
    }
    else if (typeof children === "function")
        _children = children({ isExpanded: treeviewState.isExpanded, render: treeviewState.render });
    if (_children && _children.length > 0) {
        if (((_b = _children[0]) === null || _b === void 0 ? void 0 : _b.type) !== TreeView)
            _children = React__default.createElement("ul", { className: "bd-treeview" }, _children);
    }
    if (!focus)
        props = __assign({ tabIndex: -1 }, props);
    return (React__default.createElement("li", null,
        React__default.createElement("a", __assign({ onClick: clickHandler, className: classNames("bd-treeview-item", className, {
                disabled: disabled,
                "bd-treeview-compact": compact,
                "bd-treeview-menu": variant === "menu",
                "bd-treeview-selected": selected,
            }), href: href }, props),
            React__default.createElement("span", { className: classNames({ "cur-pointer": !!_children }), onClick: onClickSpan }, !!_children && (React__default.createElement(SvgChevronRight, { className: classNames("transition-transform", {
                    "rotate-90": treeviewState.isExpanded,
                    "rtl-rotate-180": !treeviewState.isExpanded,
                }) }))),
            React__default.createElement("div", { className: "bd-treeview-label", onClick: onTitleClick }, title)),
        _children && (React__default.createElement(Collapse, { in: treeviewState.isExpanded },
            React__default.createElement("div", null, _children)))));
};

var TreeView = function (_a) {
    var className = _a.className, variant = _a.variant, compact = _a.compact, focus = _a.focus, lazyload = _a.lazyload, children = _a.children, props = __rest(_a, ["className", "variant", "compact", "focus", "lazyload", "children"]);
    var cn = classNames("bd-treeview", className, {
        "bd-compact": compact,
        "bd-treeview-focus": focus,
    });
    var MapChildren = function (children) {
        if (typeof children === "function")
            return children;
        return React__default.Children.map(children, function (child) {
            var _a, _b;
            if (!React__default.isValidElement(child))
                return child;
            var x = child;
            if ((x === null || x === void 0 ? void 0 : x.type) === TreeViewDivider)
                return React__default.createElement("li", { className: "bd-treeview-divider" });
            if ((x === null || x === void 0 ? void 0 : x.type) === TreeView || (x === null || x === void 0 ? void 0 : x.type) === TreeViewItem) {
                var newProps = __assign(__assign({ variant: variant, compact: compact, focus: focus, lazyload: lazyload }, child.props), { children: MapChildren((_a = child.props) === null || _a === void 0 ? void 0 : _a.children) });
                return React__default.cloneElement(child, newProps);
            }
            return !((_b = child.props) === null || _b === void 0 ? void 0 : _b.children)
                ? child
                : React__default.cloneElement(child, __assign(__assign({ lazyload: lazyload }, child.props), { children: MapChildren(child.props.children) }));
        });
    };
    return (React__default.createElement("ul", __assign({ className: cn }, props), MapChildren(children)));
};

function Event() {
    var _this = this;
    var self = this;
    var handlers = [];
    self.add = function (handler, name) {
        handler.__name = name;
        handlers.push(handler);
        return {
            remove: function () { return self.remove(handler); },
            unsubscribe: function () { return self.remove(handler); },
        };
    };
    self.remove = function (handler) {
        var list = [];
        for (var i = 0; i < handlers.length; i++) {
            var h = handlers[i];
            if (h !== handler) {
                list.push(h);
            }
        }
        handlers = list;
    };
    self.dispatch = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var list = __spreadArray([], handlers, true);
        for (var i = 0; i < list.length; i++) {
            _this.run.apply(_this, __spreadArray([list[i]], args, false));
        }
    };
    self.run = function (handler) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        setTimeout(function () {
            handler.apply(void 0, args);
        }, 0);
    };
}

function Subject(initialValue, name) {
    var self = this;
    var onChange = new Event();
    self.value = initialValue;
    self.asObservable = function () { return self; };
    self.subscribe = function (handler, hname) {
        var binding = onChange.add(handler, name + "." + hname);
        var v = self.value;
        onChange.run(handler, v);
        return binding;
    };
    self.next = function (newValue) {
        self.value = newValue;
        onChange.dispatch(newValue);
    };
}

var is_positive = function (n) { return !isNaN(n) && n > 0; };
var DateHelper = {
    IsDate: function (input) {
        return Object.prototype.toString.call(input) === "[object Date]";
    },
    IsValid: function (value, cal) {
        var ymd = this.YMD(value);
        return (ymd.length === 3 &&
            is_positive(ymd[0]) &&
            is_positive(ymd[1]) &&
            is_positive(ymd[2]) &&
            ymd[1] <= 12 &&
            ymd[2] <= cal.daysInMonth(ymd[0], ymd[1]));
    },
    ValidateShamsi: function (ymd) {
        ymd = this.YMD(ymd);
        if (!ymd)
            return null;
        var y = ymd[0];
        var m = ymd[1];
        var d = ymd[2];
        if (!y)
            y = 1;
        if (!m)
            m = 1;
        if (!d)
            d = 1;
        //--------
        while (m < 1) {
            m += 12;
            y -= 1;
        }
        while (m > 12) {
            m -= 12;
            y += 1;
        }
        //--------
        while (d < 1) {
            m -= 1;
            if (m < 1) {
                m += 12;
                y -= 1;
            }
            d += Shamsi.daysInMonth(y, m);
        }
        while (d > Shamsi.daysInMonth(y, m)) {
            d -= Shamsi.daysInMonth(y, m);
            m += 1;
            if (m > 12) {
                m -= 12;
                y += 1;
            }
        }
        return [y, m, d];
    },
    ValidateMiladi: function (ymd) {
        ymd = this.YMD(ymd);
        if (!ymd)
            return null;
        var y = ymd[0];
        var m = ymd[1];
        var d = ymd[2];
        if (!y)
            y = 1;
        if (!m)
            m = 1;
        if (!d)
            d = 1;
        //--------
        while (m < 1) {
            m += 12;
            y -= 1;
        }
        while (m > 12) {
            m -= 12;
            y += 1;
        }
        //--------
        while (d < 1) {
            m -= 1;
            if (m < 1) {
                m += 12;
                y -= 1;
            }
            d += Miladi.daysInMonth(y, m);
        }
        while (d > Miladi.daysInMonth(y, m)) {
            d -= Miladi.daysInMonth(y, m);
            m += 1;
            if (m > 12) {
                m -= 12;
                y += 1;
            }
        }
        return [y, m, d];
    },
    YMD: function (ymd) {
        if (DateHelper.IsDate(ymd))
            return [
                ymd.getFullYear(),
                ymd.getMonth() + 1,
                ymd.getDate(),
                ymd.getHours(),
                ymd.getMinutes(),
                ymd.getSeconds(),
                ymd.getMilliseconds(),
            ];
        else if (typeof ymd === "string") {
            if (ymd.indexOf("-") > 0 && ymd.indexOf("T") > 0) {
                var s = ymd.trim().split("T")[0];
                ymd = s.split("-");
            }
            else {
                var s = ymd.trim().split(" ")[0];
                ymd = s.split("/");
            }
        }
        else if (Array.isArray(ymd) && ymd.length < 3) {
            var a = [];
            for (var i = 0; i < ymd.length; i++)
                a.push(ymd[i]);
            ymd = a;
            while (ymd.length < 3)
                ymd.push(1);
        }
        else if (!Array.isArray(ymd))
            return null;
        for (var k = 0; k < ymd.length; k++)
            ymd[k] = ymd[k] * 1;
        return ymd;
    },
    YMD2Date: function (ymd) {
        return new Date(ymd[0], ymd[1] - 1, ymd[2]);
    },
    format: function (fmt, ymd, calendar) {
        ymd = DateHelper.YMD(ymd);
        if (!ymd)
            return null;
        if (!fmt)
            fmt = "yyyy/MM/dd";
        var y = ymd[0] * 1;
        var m = ymd[1] * 1;
        var d = ymd[2] * 1;
        var hh = ymd.length > 3 ? ymd[3] : 0;
        var mm = ymd.length > 4 ? ymd[4] : 0;
        var ss = ymd.length > 5 ? ymd[5] : 0;
        var zz = ymd.length > 6 ? ymd[6] : 0;
        zz = zz < 10 ? "00" + zz : zz < 100 ? "0" + zz : zz + "";
        var res = "";
        for (var i = 0; i < fmt.length; i++) {
            var c = fmt[i];
            var n = 1;
            while (i + 1 < fmt.length && fmt[i + 1] === c) {
                i += 1;
                n += 1;
            }
            switch (c) {
                case "y":
                case "Y":
                    if (n === 2 && ((y >= 1300 && y < 1400) || (y >= 1900 && y < 2000)))
                        res += (y % 100) + "";
                    else
                        res += y + "";
                    break;
                case "M":
                    if (n === 1)
                        res += m + "";
                    else if (n === 2)
                        res += (m < 10 ? "0" : "") + m;
                    else
                        res += calendar.getMonthName(m);
                    break;
                case "d":
                case "D":
                    if (n === 1)
                        res += d + "";
                    else if (n === 2)
                        res += (d < 10 ? "0" : "") + d;
                    else
                        res += calendar.getDOWName(y, m, d);
                    break;
                case "h":
                    var _hh = hh > 12 ? hh - 12 : hh;
                    if (n === 1)
                        res += _hh + "";
                    else
                        res += (_hh < 10 ? "0" : "") + _hh;
                    break;
                case "H":
                    if (n === 1)
                        res += hh + "";
                    else
                        res += (hh < 10 ? "0" : "") + hh;
                    break;
                case "m":
                    if (n === 1)
                        res += mm + "";
                    else
                        res += (mm < 10 ? "0" : "") + mm;
                    break;
                case "s":
                    if (n === 1)
                        res += ss + "";
                    else
                        res += (ss < 10 ? "0" : "") + ss;
                    break;
                case "z":
                    if (n === 1)
                        res += zz.substr(0, 1);
                    else if (n === 2)
                        res += zz.substr(0, 2);
                    else
                        res += zz;
                    break;
                default:
                    while (n-- > 0)
                        res += c;
                    break;
            }
        }
        return res;
    },
};
var Miladi = new (function () {
    var self = this;
    var leaps = [
        4,
        8,
        12,
        16,
        20,
        24,
        28,
        32,
        36,
        40,
        44,
        48,
        52,
        56,
        60,
        64,
        68,
        72,
        76,
        80,
        84,
        88,
        92,
        96,
        104,
        108,
        112,
        116,
        120,
        124,
        128,
        132,
        136,
        140,
        144,
        148,
        152,
        156,
        160,
        164,
        168,
        172,
        176,
        180,
        184,
        188,
        192,
        196,
        200,
        204,
        208,
        212,
        216,
        220,
        224,
        228,
        232,
        236,
        240,
        244,
        248,
        252,
        256,
        260,
        264,
        268,
        272,
        276,
        280,
        284,
        288,
        292,
        296,
        304,
        308,
        312,
        316,
        320,
        324,
        328,
        332,
        336,
        340,
        344,
        348,
        352,
        356,
        360,
        364,
        368,
        372,
        376,
        380,
        384,
        388,
        392,
        396,
    ];
    var dow = [
        4,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
    ];
    var dow_names = ["Sat", "Sun", "Mon", "Tue", "Wed", "Thu", "Fri"];
    var month_len = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
    var m_names = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
    self.Id = "miladi";
    self.year_start = 1800;
    self.year_end = self.year_start + 400;
    self.GoToTodayText = "Today";
    self.short_dow_names = ["Sa", "Su", "Mo", "Tu", "We", "Th", "Fr"];
    self.NextMonthText = "Next Month";
    self.PrevMonthText = "Previous Month";
    function ymd_to_days(ymd) {
        ymd = DateHelper.YMD(ymd);
        if (!ymd)
            return 0;
        //------------------
        var y = ymd[0];
        var days = ymd[2] - 1;
        for (var i = self.year_start; i < y; i++)
            days += self.isleap(i) ? 366 : 365;
        for (i = 1; i < ymd[1]; i++)
            days += self.daysInMonth(y, i);
        return days;
    }
    function days_to_ymd(days) {
        var y = self.year_start;
        var m = 1;
        var d = 1;
        //------------------
        while (days > 0) {
            var days_in_year = self.isleap(y) ? 366 : 365;
            if (days < days_in_year)
                break;
            y += 1;
            days -= days_in_year;
        }
        //------------------
        while (days > 0) {
            var days_in_month = self.daysInMonth(y, m);
            if (days < days_in_month)
                break;
            m += 1;
            days -= days_in_month;
        }
        if (days > 0)
            d += days;
        return [y, m, d];
    }
    self.isleap = function (y) {
        y -= self.year_start;
        for (var i = 0; i < leaps.length && leaps[i] <= y; i++)
            if (leaps[i] === y)
                return true;
        return false;
    };
    self.daysInMonth = function (y, m) {
        while (m < 1)
            m += 12;
        while (m > 12)
            m -= 12;
        return m === 2 && self.isleap(y) ? 29 : month_len[m - 1];
    };
    self.getMonthName = function (m) {
        return m < 1 || m > 12 ? null : m_names[m - 1];
    };
    self.getDOWName = function (y, m, d) {
        return dow_names[self.DOW(y, m, d)];
    };
    self.DOW = function (y, m, d) {
        var d1_1 = dow[y - self.year_start];
        var m_dow = [0, 3, 3, 6, 1, 4, 6, 2, 5, 0, 3, 5];
        var res = (d1_1 + m_dow[m - 1]) % 7;
        if (d > 0)
            res = (res + (d - 1)) % 7;
        return res;
    };
    self.addDaysYMD = function (ymd, amount) {
        if (ymd == null)
            ymd = [self.year_start, 1, 1];
        var days = ymd_to_days(ymd);
        return days_to_ymd(days + amount);
    };
    self.addDays = function (ymd, amount) {
        return DateHelper.format("yyyy/MM/dd", self.addDaysYMD(ymd, amount), self);
    };
    self.addMonths = function (ymd, amount) {
        ymd = DateHelper.YMD(ymd);
        if (!ymd)
            return null;
        var y = ymd[0];
        var m = ymd[1] + amount;
        var d = ymd[2];
        //-------------
        while (m < 1) {
            m += 12;
            y -= 1;
        }
        while (m > 12) {
            m -= 12;
            y += 1;
        }
        return DateHelper.format("yyyy/MM/dd", [y, m, d], self);
    };
    self.subtract = function (ymd1, ymd2) {
        return ymd_to_days(ymd1) - ymd_to_days(ymd2);
    };
    self.baseOffset = function (ymd) {
        return ymd_to_days([1821, 3, 21]);
    };
    self.toShamsiYMD = function (ymd) {
        var x = ymd_to_days(ymd) - self.baseOffset() + Shamsi.baseOffset();
        return Shamsi.addDaysYMD(null, x);
    };
    self.toShamsi = function (ymd) {
        return !ymd ? null : DateHelper.format("yyyy/MM/dd", self.toShamsiYMD(ymd), self);
    };
    self.parse = function (ymd) {
        return DateHelper.YMD2Date(DateHelper.YMD(ymd));
    };
    self.now = function () {
        var dt = new Date();
        var m = dt.getMonth() + 1; //months from 1-12
        var d = dt.getDate();
        var y = dt.getFullYear();
        var res = y + "/" + (m < 10 ? "0" : "") + m + "/" + (d < 10 ? "0" : "") + d;
        return res;
    };
    self.validate = function (value) {
        return DateHelper.ValidateMiladi(value);
    };
    self.isValid = function (value) {
        return DateHelper.IsValid(value, self);
    };
    self.format = function (dateFormat, value) {
        return DateHelper.format(dateFormat, DateHelper.YMD(value), self);
    };
})();
var Shamsi = new (function () {
    var self = this;
    var leaps = [
        1,
        5,
        10,
        14,
        18,
        22,
        26,
        30,
        34,
        38,
        43,
        47,
        51,
        55,
        59,
        63,
        67,
        71,
        76,
        80,
        84,
        88,
        92,
        96,
        100,
        104,
        109,
        113,
        117,
        121,
        125,
        129,
        133,
        137,
        142,
        146,
        150,
        154,
        158,
        162,
        166,
        170,
        175,
        179,
        183,
        187,
        191,
        195,
        199,
        203,
        208,
        212,
        216,
        220,
        224,
        228,
        232,
        236,
        241,
        245,
        249,
        253,
        257,
        261,
        265,
        269,
        274,
        278,
        282,
        286,
        290,
        294,
        298,
    ];
    var dow = [
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        1,
        3,
        4,
        5,
        6,
        1,
        2,
        3,
        4,
        6,
        0,
        1,
        2,
        4,
        5,
        6,
        0,
        2,
        3,
        4,
        5,
        0,
        1,
        2,
        3,
        5,
    ];
    var dow_names = ["شنبه", "یکشنبه", "دوشنبه", "سه شنبه", "چهارشنبه", "پنجشنبه", "جمعه"];
    var m_names = ["فروردین", "اردیبهشت", "خرداد", "تیر", "مرداد", "شهریور", "مهر", "آبان", "آذر", "دی", "بهمن", "اسفند"];
    self.Id = "shamsi";
    self.year_start = 1200;
    self.year_end = self.year_start + 400;
    self.GoToTodayText = "برو به امروز";
    self.short_dow_names = ["ش", "ی", "د", "س", "چ", "پ", "ج"];
    self.NextMonthText = "ماه بعد";
    self.PrevMonthText = "ماه قبل";
    function ymd_to_days(ymd) {
        ymd = DateHelper.YMD(ymd);
        if (!ymd)
            return 0;
        //------------------
        var y = ymd[0];
        var days = ymd[2] - 1;
        for (var i = self.year_start; i < y; i++)
            days += self.isleap(i) ? 366 : 365;
        for (i = 1; i < ymd[1]; i++)
            days += self.daysInMonth(y, i);
        return days;
    }
    function days_to_ymd(days) {
        var y = self.year_start;
        var m = 1;
        var d = 1;
        //------------------
        while (days > 0) {
            var days_in_year = self.isleap(y) ? 366 : 365;
            if (days < days_in_year)
                break;
            y += 1;
            days -= days_in_year;
        }
        //------------------
        while (days > 0) {
            var days_in_month = self.daysInMonth(y, m);
            if (days < days_in_month)
                break;
            m += 1;
            days -= days_in_month;
        }
        if (days > 0)
            d += days;
        return [y, m, d];
    }
    self.isleap = function (y) {
        y -= self.year_start;
        for (var i = 0; i < leaps.length && leaps[i] <= y; i++)
            if (leaps[i] === y)
                return true;
        return false;
    };
    self.daysInMonth = function (y, m) {
        while (m < 1)
            m += 12;
        while (m > 12)
            m -= 12;
        return m < 7 ? 31 : m < 12 || self.isleap(y) ? 30 : 29;
    };
    self.getMonthName = function (m) {
        return m < 1 || m > 12 ? null : m_names[m - 1];
    };
    self.getDOWName = function (y, m, d) {
        return dow_names[self.DOW(y, m, d)];
    };
    self.DOW = function (y, m, d) {
        var d1_1 = dow[y - self.year_start];
        var m_dow = [0, 3, 6, 2, 5, 1, 4, 6, 1, 3, 5, 0];
        var res = (d1_1 + m_dow[m - 1]) % 7;
        if (d > 0)
            res = (res + (d - 1)) % 7;
        return res;
    };
    self.addDaysYMD = function (ymd, amount) {
        if (ymd == null)
            ymd = [self.year_start, 1, 1];
        var days = ymd_to_days(ymd);
        return days_to_ymd(days + amount);
    };
    self.addDays = function (ymd, amount) {
        return DateHelper.format("yyyy/MM/dd", self.addDaysYMD(ymd, amount), self);
    };
    self.addMonths = function (ymd, amount) {
        ymd = DateHelper.YMD(ymd);
        if (!ymd)
            return null;
        var y = ymd[0];
        var m = ymd[1] + amount;
        var d = ymd[2];
        //-------------
        while (m < 1) {
            m += 12;
            y -= 1;
        }
        while (m > 12) {
            m -= 12;
            y += 1;
        }
        return DateHelper.format("yyyy/MM/dd", [y, m, d], self);
    };
    self.subtract = function (ymd1, ymd2) {
        if (DateHelper.IsDate(ymd1))
            ymd1 = Miladi.toShamsiYMD(ymd1);
        if (DateHelper.IsDate(ymd2))
            ymd2 = Miladi.toShamsiYMD(ymd2);
        return ymd_to_days(ymd1) - ymd_to_days(ymd2);
    };
    self.baseOffset = function () {
        return ymd_to_days([1200, 1, 1]);
    };
    self.toMiladiYMD = function (ymd) {
        if (DateHelper.IsDate(ymd))
            return Miladi.format("yyyy/MM/dd", ymd);
        var x = ymd_to_days(ymd) - self.baseOffset() + Miladi.baseOffset();
        return Miladi.addDaysYMD(null, x);
    };
    self.toMiladi = function (ymd) {
        return !ymd ? null : DateHelper.format("yyyy/MM/dd", self.toMiladiYMD(ymd), self);
    };
    self.parse = function (ymd) {
        return DateHelper.YMD2Date(self.toMiladiYMD(ymd));
    };
    self.now = function () {
        return Miladi.toShamsi(new Date());
    };
    self.validate = function (value) {
        return DateHelper.ValidateShamsi(value);
    };
    self.isValid = function (value) {
        return DateHelper.IsValid(value, self);
    };
    self.format = function (dateFormat, value) {
        var is_sys_date = DateHelper.IsDate(value);
        var ymd = is_sys_date ? Miladi.toShamsiYMD(value) : DateHelper.YMD(value);
        if (is_sys_date)
            ymd = [ymd[0], ymd[1], ymd[2], value.getHours(), value.getMinutes(), value.getSeconds(), value.getMilliseconds()];
        return DateHelper.format(dateFormat, ymd, self);
    };
})();
var toHHMM = function (ymd) {
    if (typeof ymd === "string") {
        var i1 = ymd.indexOf(":");
        var hh = getNumber(ymd, i1, -1);
        if (hh === -1)
            return null;
        var mm = getNumber(ymd, i1, 1);
        if (mm === -1)
            return null;
        return toNumber(hh) + ":" + toNumber(mm);
    }
    if (DateHelper.IsDate(ymd)) {
        return toNumber(ymd.getHours()) + ":" + toNumber(ymd.getMinutes());
    }
    return null;
};
var toHHMMSS = function (ymd) {
    if (typeof ymd === "string") {
        var i1 = ymd.indexOf(":");
        var hh = getNumber(ymd, i1, -1);
        if (hh === -1)
            return null;
        var i2 = ymd.indexOf(":", i1 + 1);
        var mm = getNumber(ymd, i2, -1);
        if (mm === -1)
            return null;
        var ss = getNumber(ymd, i2, 1);
        if (ss === -1)
            return null;
        return toNumber(hh) + ":" + toNumber(mm) + ":" + toNumber(ss);
    }
    if (DateHelper.IsDate(ymd)) {
        return toNumber(ymd.getHours()) + ":" + toNumber(ymd.getMinutes()) + ":" + toNumber(ymd.getSeconds());
    }
    return null;
};
function toNumber(x) {
    return x < 10 ? "0" + x.toString() : x.toString();
}
function getNumber(s, i, delta) {
    i += delta;
    var cn1 = i >= 0 && i < s.length && s[i] >= "0" && s[i] <= "9" ? Number(s[i]) : -1;
    i += delta;
    var cn2 = i >= 0 && i < s.length && s[i] >= "0" && s[i] <= "9" ? Number(s[i]) : 0;
    if (cn1 === -1)
        return -1;
    return delta == -1 ? cn2 * 10 + cn1 : cn1 * 10 + cn2;
}
var miladi = Miladi;
var shamsi = Shamsi;
/*
export const miladi = {
    toShamsi: (ymd: null | string | Date) => Miladi.toShamsi(ymd),
    parse: (ymd: null | string | Date) => Miladi.parse(ymd),
    isValid: (ymd: null | string | Date) => Miladi.isValid(ymd),
    addDays: (ymd: null | string | Date, days: number) => Miladi.addDays(ymd, days),
    addMonths: (ymd: null | string | Date, months: number) => Miladi.addMonths(ymd, months),
    subtract: (ymd1: null | string | Date, ymd2: null | string | Date) => Miladi.subtract(ymd1, ymd2),
    format: (formatText: string, ymd: null | string | Date) => Miladi.format(formatText, ymd),
    toHHMM,
    toHHMMSS,
};

export const shamsi = {
    toMiladi: (ymd: null | string | Date) => Shamsi.toMiladi(ymd),
    parse: (ymd: null | string | Date) => Shamsi.parse(ymd),
    isValid: (ymd: null | string | Date) => Shamsi.isValid(ymd),
    addDays: (ymd: null | string | Date, days: number) => Shamsi.addDays(ymd, days),
    addMonths: (ymd: null | string | Date, months: number) => Shamsi.addMonths(ymd, months),
    subtract: (ymd1: null | string | Date, ymd2: null | string | Date) => Shamsi.subtract(ymd1, ymd2),
    format: (formatText: string, ymd: null | string | Date) => Shamsi.format(formatText, ymd),
    toHHMM,
    toHHMMSS,
};
*/

export { AppBar, Avatar, AvatarGroup, Badge, BasicTable, Button, ButtonGroup, Card, CardBody, CardFooter, CardHeader, CardMedia, CardSubTitle, CardText, CardTitle, Chip, Event, Flex, Form, FormRow, List, ListDivider, ListItem, Menu, MenuDivider, MenuHeader, MenuItem, MsgBox, MsgBoxContainer, Panel, Paper, Phantom, ResizeWatch, ScrollPane, SubMenu, Subject, Switch, TabStrip, TabStripItem, TextField, Toggle, Toolbar, Transition, TreeView, TreeViewDivider, TreeViewItem, easings, helper, miladi, msgbox, shamsi, toHHMM, toHHMMSS, useAutoFocus };
//# sourceMappingURL=index.esm.js.map
