import React, { CSSProperties, ReactElement } from "react";
interface ColumnProps {
    accessor?: string;
    Header?: string | React.ReactNode;
    name?: string;
    title?: string;
    width?: any;
    minWidth?: any;
    cellCSS?: string | (({ row, rowIndex, columnName, columnIndex }: {
        row: any;
        rowIndex: any;
        columnName: any;
        columnIndex: any;
    }) => string);
    headerCSS?: string | (({ columnName, columnIndex }: {
        columnName: any;
        columnIndex: any;
    }) => string);
    getDisplayValue?: ({ value, row, rowIndex, columnName, columnIndex }: {
        value: any;
        row: any;
        rowIndex: any;
        columnName: any;
        columnIndex: any;
    }) => ReactElement;
    Cell?: ({ value, row, rowIndex, columnName, columnIndex }: {
        value: any;
        row: any;
        rowIndex: any;
        columnName: any;
        columnIndex: any;
    }) => ReactElement;
    render?: ({ row, rowIndex, columnName, columnIndex, defaultProps }: {
        row: any;
        rowIndex: any;
        columnName: any;
        columnIndex: any;
        defaultProps: any;
    }) => ReactElement;
    onCellClick?: ({ row, rowIndex, columnName, columnIndex, event }: {
        row: any;
        rowIndex: any;
        columnName: any;
        columnIndex: any;
        event: any;
    }) => void;
    onCellDoubleClick?: ({ row, rowIndex, columnName, columnIndex, event }: {
        row: any;
        rowIndex: any;
        columnName: any;
        columnIndex: any;
        event: any;
    }) => void;
}
interface BasicTableProps {
    fullWidth?: boolean;
    hover?: boolean;
    striped?: boolean;
    compact?: boolean;
    nowrap?: boolean;
    fixed?: boolean;
    columns?: ColumnProps[];
    data?: any[];
    selectedIndices?: any[];
    selectedRows?: any[];
    multiSelect?: boolean;
    singleSelect?: boolean;
    hideCheckbox?: boolean;
    draggable?: boolean;
    disableToggleOnClick?: boolean;
    className?: string;
    style?: CSSProperties | undefined;
    maxHeight?: any;
    maxWidth?: any;
    hideHeader?: boolean;
    actions?: React.ReactNode;
    children?: React.ReactNode;
    cellCSS?: string | (({ row, rowIndex, columnName, columnIndex }: {
        row: any;
        rowIndex: any;
        columnName: any;
        columnIndex: any;
    }) => string);
    headerCSS?: ({ columnName, columnIndex }: {
        columnName: any;
        columnIndex: any;
    }) => string;
    renderCell?: ({ row, columnName, value, rowIndex, columnIndex }: {
        row: any;
        columnName: any;
        value: any;
        rowIndex: any;
        columnIndex: any;
    }) => any;
    renderTD?: ({ row, columnName, rowIndex, columnIndex, defaultProps, renderCell }: {
        row: any;
        columnName: any;
        rowIndex: any;
        columnIndex: any;
        defaultProps: any;
        renderCell: any;
    }) => React.ReactNode;
    onSelectionChanged?: (indices: any, currrentIndex: number) => void;
    onDragStart?: (ev: any, fromRowIndex: number) => void;
    onDragEnd?: (ev: any, fromRowIndex: number) => void;
    onCanDrop?: (ev: any, fromRowIndex: number, newRowIndex: number, newColumnIndex: number) => boolean;
    onDrop?: (ev: any, fromRowIndex: number, newRowIndex: number, newColumnIndex: number) => void;
    onRowClick?: ({ row, rowIndex, event }: {
        row: any;
        rowIndex: any;
        event: any;
    }) => void;
    onRowDoubleClick?: ({ row, rowIndex, event }: {
        row: any;
        rowIndex: any;
        event: any;
    }) => void;
    [x: string]: any;
}
export declare const BasicTable: ({ hover, striped, compact, nowrap, fixed, columns, data, selectedIndices, multiSelect, singleSelect, hideCheckbox, draggable, disableToggleOnClick, className, style, maxHeight, maxWidth, children, actions, hideHeader, renderCell, renderTD, onSelectionChanged, onDragStart, onDragEnd, onCanDrop, onDrop, cellCSS, headerCSS, onRowClick, onRowDoubleClick, ...props }: BasicTableProps) => React.JSX.Element;
export {};
